//+------------------------------------------------------------------+
//|                                                    YBM_AB_EA.mq5 |
//|                                                   Brolin Mukoswa |
//|                         https://www.mql5.com/en/users/fx_veteran |
//+------------------------------------------------------------------+
#property copyright "Brolin Mukoswa"
#property link      "https://www.mql5.com/en/users/fx_veteran"
#property version   "1.00"

#include<Trade\Trade.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

enum entry_opt{
  
  C,           //On Tick
  D            //Candle Close
};


input int history_bars = 5000;                           //History bars
input string start_time = "08:00";        //Trading Start Time
input string stop_time = "17:00";        //Trading End Time
input string pairs = "EURUSD,AUDNZD,GBPUSD";   //Traded Symbols (separated by ",")
input int max_trades = 1;                //Max Trades at a time
input int total_trades = 10;             //Max Trades during Trading Time
input entry_opt entry_option;            //Trade Entry Option
input double lotsize = 0.1;              //Lotsize
input double stoploss = 30;              //Stoploss (pips)
input double takeprofit = 30;              //Takeprofit (pips)
input double trail_stop = 30;              //Trailing Stop (pips)
//input double pips_away = 10;               //Pips away from lines
//input double pips_past = 10;               //Pips past lines
input double minutes = 10;                 //Minutes btwn signals
input double pip_adjust_10 = 1;                          //Pip adjustment (factor of 10s)

input string ma_note = "";                               //MA Filters
input bool ma_crossover = false;                         //__ crossover MAs, each MA has it's own cross over
input bool ma_all_to_large = false;                      //__ largest MA, rest above/below the largest
input string note_seq_a = "---------- Sequence A ----------";//MA+STO Sequence A

input string ma_1_note = "";                             //MA 1a
input bool ma_1_use = true;                              //1a__ use
input ENUM_TIMEFRAMES ma_1_tf = PERIOD_CURRENT;          //1a__ tf
input int ma_1_period = 20;                              //1a__ period
input ENUM_MA_METHOD ma_1_method = MODE_EMA;             //1a__ method
input ENUM_APPLIED_PRICE ma_1_price = PRICE_CLOSE;       //1a__ price
input int ma_1_shift = 0;                                //1a__ shift
//input color ma_1_clr = clrYellow;                        //1a__ color
//input int ma_1_w = 1;                                    //1a__ width
//input ENUM_LINE_STYLE ma_1_st = STYLE_SOLID;             //1a__ style
input int ma_1_xperiod = 40;                             //1a__ crossover (if used)
//input int ma_1_xw = 1;                                   //1a__ width
//input ENUM_LINE_STYLE ma_1_xst = STYLE_DOT;              //1a__ style

input string ma_2_note = "";                             //MA 2a
input bool ma_2_use = false;                             //2a__ use
input ENUM_TIMEFRAMES ma_2_tf = PERIOD_CURRENT;          //2a__ tf
input int ma_2_period = 20;                              //2a__ period
input ENUM_MA_METHOD ma_2_method = MODE_SMA;             //2a__ method
input ENUM_APPLIED_PRICE ma_2_price = PRICE_CLOSE;       //2a__ price
input int ma_2_shift = 0;                                //2a__ shift
//input color ma_2_clr = clrAqua;                          //2a__ color
//input int ma_2_w = 1;                                    //2a__ width
//input ENUM_LINE_STYLE ma_2_st = STYLE_SOLID;             //2a__ style
input int ma_2_xperiod = 40;                             //2a__ crossover (if used)
//input int ma_2_xw = 1;                                   //2a__ width
//input ENUM_LINE_STYLE ma_2_xst = STYLE_DOT;              //2a__ style

input string ma_3_note = "";                             //MA 3a
input bool ma_3_use = false;                             //3a__ use
input ENUM_TIMEFRAMES ma_3_tf = PERIOD_CURRENT;          //3a__ tf
input int ma_3_period = 20;                              //3a__ period
input ENUM_MA_METHOD ma_3_method = MODE_SMA;             //3a__ method
input ENUM_APPLIED_PRICE ma_3_price = PRICE_CLOSE;       //3a__ price
input int ma_3_shift = 0;                                //3a__ shift
//input color ma_3_clr = clrRed;                           //3a__ color
//input int ma_3_w = 1;                                    //3a__ width
//input ENUM_LINE_STYLE ma_3_st = STYLE_SOLID;             //3a__ style
input int ma_3_xperiod = 40;                             //3a__ crossover (if used)
//input int ma_3_xw = 1;                                   //3a__ width
//input ENUM_LINE_STYLE ma_3_xst = STYLE_DOT;              //3a__ style

input string ma_4_note = "";                             //MA 4a
input bool ma_4_use = false;                             //4a__ use
input ENUM_TIMEFRAMES ma_4_tf = PERIOD_CURRENT;          //4a__ tf
input int ma_4_period = 20;                              //4a__ period
input ENUM_MA_METHOD ma_4_method = MODE_SMA;             //4a__ method
input ENUM_APPLIED_PRICE ma_4_price = PRICE_CLOSE;       //4a__ price
input int ma_4_shift = 0;                                //4a__ shift
//input color ma_4_clr = clrWhite;                         //4a__ color
//input int ma_4_w = 1;                                    //4a__ width
//input ENUM_LINE_STYLE ma_4_st = STYLE_SOLID;             //4a__ style
input int ma_4_xperiod = 40;                             //4a__ crossover (if used)
//input int ma_4_xw = 1;                                   //4a__ width
//input ENUM_LINE_STYLE ma_4_xst = STYLE_DOT;              //4a__ style

input string ma_5_note = "";                             //MA 5a
input bool ma_5_use = false;                             //5a__ use
input ENUM_TIMEFRAMES ma_5_tf = PERIOD_CURRENT;          //5a__ tf
input int ma_5_period = 20;                              //5a__ period
input ENUM_MA_METHOD ma_5_method = MODE_SMA;             //5a__ method
input ENUM_APPLIED_PRICE ma_5_price = PRICE_CLOSE;       //5a__ price
input int ma_5_shift = 0;                                //5a__ shift
//input color ma_4_clr = clrWhite;                         //4a__ color
//input int ma_4_w = 1;                                    //4a__ width
//input ENUM_LINE_STYLE ma_4_st = STYLE_SOLID;             //4a__ style
input int ma_5_xperiod = 40;                             //5a__ crossover (if used)
//input int ma_4_xw = 1;                                   //4a__ width
//input ENUM_LINE_STYLE ma_4_xst = STYLE_DOT;              //4a__ style


input string ma_6_note = "";                             //MA 6a
input bool ma_6_use = false;                             //6a__ use
input ENUM_TIMEFRAMES ma_6_tf = PERIOD_CURRENT;          //6a__ tf
input int ma_6_period = 20;                              //6a__ period
input ENUM_MA_METHOD ma_6_method = MODE_SMA;             //6a__ method
input ENUM_APPLIED_PRICE ma_6_price = PRICE_CLOSE;       //6a__ price
input int ma_6_shift = 0;                                //6a__ shift
//input color ma_4_clr = clrWhite;                         //4a__ color
//input int ma_4_w = 1;                                    //4a__ width
//input ENUM_LINE_STYLE ma_4_st = STYLE_SOLID;             //4a__ style
input int ma_6_xperiod = 40;                             //6a__ crossover (if used)
//input int ma_4_xw = 1;                                   //4a__ width
//input ENUM_LINE_STYLE ma_4_xst = STYLE_DOT;              //4a__ style


input string sto_1_note = "";                            //Stochastic 1a
input bool sto_1_use = false;                            //1a__ use
input ENUM_TIMEFRAMES sto_1_tf = PERIOD_CURRENT;         //1a__ tf
input int sto_1_k_period = 10;                           //1a__ k period
input int sto_1_d_period = 5;                            //1a__ d period
input int sto_1_s_period = 3;                            //1a__ s period
input ENUM_MA_METHOD sto_1_method = MODE_SMA;            //1a__ ma method
input ENUM_STO_PRICE sto_1_price = STO_LOWHIGH;          //1a__ price
input bool sto_1_inbetween = false;                      //1a__ limit to OB/OS range
input int sto_1_ob = 80;                                 //1a__ __ OB
input int sto_1_os = 20;                                 //1a__ __ OS

input string sto_2_note = "";                            //Stochastic 2a
input bool sto_2_use = false;                            //2a__ use
input ENUM_TIMEFRAMES sto_2_tf = PERIOD_CURRENT;         //2a__ tf
input int sto_2_k_period = 10;                           //2a__ k period
input int sto_2_d_period = 5;                            //2a__ d period
input int sto_2_s_period = 3;                            //2a__ s period
input ENUM_MA_METHOD sto_2_method = MODE_SMA;            //2a__ ma method
input ENUM_STO_PRICE sto_2_price = STO_LOWHIGH;          //2a__ price
input bool sto_2_inbetween = false;                      //2a__ limit to OB/OS range
input int sto_2_ob = 80;                                 //2a__ __ OB
input int sto_2_os = 20;                                 //2a__ __ OS

input string sto_3_note = "";                            //Stochastic 3a
input bool sto_3_use = false;                            //3a__ use
input ENUM_TIMEFRAMES sto_3_tf = PERIOD_CURRENT;         //3a__ tf
input int sto_3_k_period = 10;                           //3a__ k period
input int sto_3_d_period = 5;                            //3a__ d period
input int sto_3_s_period = 3;                            //3a__ s period
input ENUM_MA_METHOD sto_3_method = MODE_SMA;            //3a__ ma method
input ENUM_STO_PRICE sto_3_price = STO_LOWHIGH;          //3a__ price
input bool sto_3_inbetween = false;                      //3a__ limit to OB/OS range
input int sto_3_ob = 80;                                 //3a__ __ OB
input int sto_3_os = 20;                                 //3a__ __ OS

input string sto_4_note = "";                            //Stochastic 4a
input bool sto_4_use = false;                            //4a__ use
input ENUM_TIMEFRAMES sto_4_tf = PERIOD_CURRENT;         //4a__ tf
input int sto_4_k_period = 10;                           //4a__ k period
input int sto_4_d_period = 5;                            //4a__ d period
input int sto_4_s_period = 3;                            //4a__ s period
input ENUM_MA_METHOD sto_4_method = MODE_SMA;            //4a__ ma method
input ENUM_STO_PRICE sto_4_price = STO_LOWHIGH;          //4a__ price
input bool sto_4_inbetween = false;                      //4a__ limit to OB/OS range
input int sto_4_ob = 80;                                 //4a__ __ OB
input int sto_4_os = 20;                                 //4a__ __ OS

input string sto_5_note = "";                            //Stochastic 5a
input bool sto_5_use = false;                            //5a__ use
input ENUM_TIMEFRAMES sto_5_tf = PERIOD_CURRENT;         //5a__ tf
input int sto_5_k_period = 10;                           //5a__ k period
input int sto_5_d_period = 5;                            //5a__ d period
input int sto_5_s_period = 3;                            //5a__ s period
input ENUM_MA_METHOD sto_5_method = MODE_SMA;            //5a__ ma method
input ENUM_STO_PRICE sto_5_price = STO_LOWHIGH;          //5a__ price
input bool sto_5_inbetween = false;                      //5a__ limit to OB/OS range
input int sto_5_ob = 80;                                 //5a__ __ OB
input int sto_5_os = 20;                                 //5a__ __ OS


input string sto_6_note = "";                            //Stochastic 6a
input bool sto_6_use = false;                            //6a__ use
input ENUM_TIMEFRAMES sto_6_tf = PERIOD_CURRENT;         //6a__ tf
input int sto_6_k_period = 10;                           //6a__ k period
input int sto_6_d_period = 5;                            //6a__ d period
input int sto_6_s_period = 3;                            //6a__ s period
input ENUM_MA_METHOD sto_6_method = MODE_SMA;            //6a__ ma method
input ENUM_STO_PRICE sto_6_price = STO_LOWHIGH;          //6a__ price
input bool sto_6_inbetween = false;                      //6a__ limit to OB/OS range
input int sto_6_ob = 80;                                 //6a__ __ OB
input int sto_6_os = 20;                                 //6a__ __ OS


input string macd_1_note ="---- A - MACD 1 ----";        //A_MACD_1
input bool macd_1_use = false;                           //__ use
input ENUM_TIMEFRAMES macd_1_tf = PERIOD_CURRENT;        //__ tf
input int macd_1_period_fast = 12;                       //__ fast period
input int macd_1_period_slow = 26;                       //__ slow period
input int macd_1_period_signal = 9;                      //__ signal period
input ENUM_APPLIED_PRICE macd_1_price = PRICE_CLOSE;     //__ price

input string macd_2_note ="---- A - MACD 2 ----";        //A_MACD_2
input bool macd_2_use = false;                           //__ use
input ENUM_TIMEFRAMES macd_2_tf = PERIOD_CURRENT;        //__ tf
input int macd_2_period_fast = 12;                       //__ fast period
input int macd_2_period_slow = 26;                       //__ slow period
input int macd_2_period_signal = 9;                      //__ signal period
input ENUM_APPLIED_PRICE macd_2_price = PRICE_CLOSE;     //__ price

input string macd_3_note ="---- A - MACD 3 ----";        //A_MACD_3
input bool macd_3_use = false;                           //__ use
input ENUM_TIMEFRAMES macd_3_tf = PERIOD_CURRENT;        //__ tf
input int macd_3_period_fast = 12;                       //__ fast period
input int macd_3_period_slow = 26;                       //__ slow period
input int macd_3_period_signal = 9;                      //__ signal period
input ENUM_APPLIED_PRICE macd_3_price = PRICE_CLOSE;     //__ price

input string macd_4_note ="---- A - MACD 4 ----";        //A_MACD_4
input bool macd_4_use = false;                           //__ use
input ENUM_TIMEFRAMES macd_4_tf = PERIOD_CURRENT;        //__ tf
input int macd_4_period_fast = 12;                       //__ fast period
input int macd_4_period_slow = 26;                       //__ slow period
input int macd_4_period_signal = 9;                      //__ signal period
input ENUM_APPLIED_PRICE macd_4_price = PRICE_CLOSE;     //__ price

input string macd_5_note ="---- A - MACD 5 ----";        //A_MACD_5
input bool macd_5_use = false;                           //__ use
input ENUM_TIMEFRAMES macd_5_tf = PERIOD_CURRENT;        //__ tf
input int macd_5_period_fast = 12;                       //__ fast period
input int macd_5_period_slow = 26;                       //__ slow period
input int macd_5_period_signal = 9;                      //__ signal period
input ENUM_APPLIED_PRICE macd_5_price = PRICE_CLOSE;     //__ price


input string macd_6_note ="---- A - MACD 6 ----";        //A_MACD_6
input bool macd_6_use = false;                           //__ use
input ENUM_TIMEFRAMES macd_6_tf = PERIOD_CURRENT;        //__ tf
input int macd_6_period_fast = 12;                       //__ fast period
input int macd_6_period_slow = 26;                       //__ slow period
input int macd_6_period_signal = 9;                      //__ signal period
input ENUM_APPLIED_PRICE macd_6_price = PRICE_CLOSE;     //__ price

input string note_seq_b = "---------- Sequence B ----------";//MA+STO Sequence B
input bool seqb_use = false;                             //__ use seqeunce B?

input string ma_1b_note = "";                            //MA 1b
input bool ma_1b_use = false;                            //1b__ use
input ENUM_TIMEFRAMES ma_1b_tf = PERIOD_CURRENT;         //1b__ tf
input int ma_1b_period = 30;                             //1b__ period
input ENUM_MA_METHOD ma_1b_method = MODE_EMA;            //1b__ method
input ENUM_APPLIED_PRICE ma_1b_price = PRICE_CLOSE;      //1b__ price
input int ma_1b_shift = 0;                               //1b__ shift
//input color ma_1b_clr = clrRoyalBlue;                    //1b__ color
//input int ma_1b_w = 1;                                   //1b__ width
//input ENUM_LINE_STYLE ma_1b_st = STYLE_SOLID;            //1b__ style
input int ma_1b_xperiod = 50;                            //1b__ crossover (if used)
//input int ma_1b_xw = 1;                                  //1b__ width
//input ENUM_LINE_STYLE ma_1b_xst = STYLE_DOT;             //1b__ style

input string ma_2b_note = "";                            //MA 2b
input bool ma_2b_use = false;                            //2b__ use
input ENUM_TIMEFRAMES ma_2b_tf = PERIOD_CURRENT;         //2b__ tf
input int ma_2b_period = 30;                             //2b__ period
input ENUM_MA_METHOD ma_2b_method = MODE_SMA;            //2b__ method
input ENUM_APPLIED_PRICE ma_2b_price = PRICE_CLOSE;      //2b__ price
input int ma_2b_shift = 0;                               //2b__ shift
//input color ma_2b_clr = clrOrange;                       //2b__ color
//input int ma_2b_w = 1;                                   //2b__ width
//input ENUM_LINE_STYLE ma_2b_st = STYLE_SOLID;            //2b__ style
input int ma_2b_xperiod = 50;                            //2b__ crossover (if used)
//input int ma_2b_xw = 1;                                  //2b__ width
//input ENUM_LINE_STYLE ma_2b_xst = STYLE_DOT;             //2b__ style

input string ma_3b_note = "";                            //MA 3b
input bool ma_3b_use = false;                            //3b__ use
input ENUM_TIMEFRAMES ma_3b_tf = PERIOD_CURRENT;         //3b__ tf
input int ma_3b_period = 30;                             //3b__ period
input ENUM_MA_METHOD ma_3b_method = MODE_SMA;            //3b__ method
input ENUM_APPLIED_PRICE ma_3b_price = PRICE_CLOSE;      //3b__ price
input int ma_3b_shift = 0;                               //3b__ shift
//input color ma_3b_clr = clrPink;                         //3b__ color
//input int ma_3b_w = 1;                                   //3b__ width
//input ENUM_LINE_STYLE ma_3b_st = STYLE_SOLID;            //3b__ style
input int ma_3b_xperiod = 50;                            //3b__ crossover (if used)
//input int ma_3b_xw = 1;                                  //3b__ width
//input ENUM_LINE_STYLE ma_3b_xst = STYLE_DOT;             //3b__ style

input string ma_4b_note = "";                            //MA 4b
input bool ma_4b_use = false;                            //4b__ use
input ENUM_TIMEFRAMES ma_4b_tf = PERIOD_CURRENT;         //4b__ tf
input int ma_4b_period = 30;                             //4b__ period
input ENUM_MA_METHOD ma_4b_method = MODE_SMA;            //4b__ method
input ENUM_APPLIED_PRICE ma_4b_price = PRICE_CLOSE;      //4b__ price
input int ma_4b_shift = 0;                               //4b__ shift
//input color ma_4b_clr = clrGreen;                        //4b__ color
//input int ma_4b_w = 1;                                   //4b__ width
//input ENUM_LINE_STYLE ma_4b_st = STYLE_SOLID;            //4b__ style
input int ma_4b_xperiod = 50;                            //4b__ crossover (if used)
//input int ma_4b_xw = 1;                                  //4b__ width
//input ENUM_LINE_STYLE ma_4b_xst = STYLE_DOT;             //4b__ style

input string ma_5b_note = "";                            //MA 5b
input bool ma_5b_use = false;                            //5b__ use
input ENUM_TIMEFRAMES ma_5b_tf = PERIOD_CURRENT;         //5b__ tf
input int ma_5b_period = 30;                             //5b__ period
input ENUM_MA_METHOD ma_5b_method = MODE_SMA;            //5b__ method
input ENUM_APPLIED_PRICE ma_5b_price = PRICE_CLOSE;      //5b__ price
input int ma_5b_shift = 0;                               //5b__ shift
//input color ma_4b_clr = clrGreen;                        //4b__ color
//input int ma_4b_w = 1;                                   //4b__ width
//input ENUM_LINE_STYLE ma_4b_st = STYLE_SOLID;            //4b__ style
input int ma_5b_xperiod = 50;                            //5b__ crossover (if used)
//input int ma_4b_xw = 1;                                  //4b__ width
//input ENUM_LINE_STYLE ma_4b_xst = STYLE_DOT;             //4b__ style


input string ma_6b_note = "";                            //MA 6b
input bool ma_6b_use = false;                            //6b__ use
input ENUM_TIMEFRAMES ma_6b_tf = PERIOD_CURRENT;         //6b__ tf
input int ma_6b_period = 30;                             //6b__ period
input ENUM_MA_METHOD ma_6b_method = MODE_SMA;            //6b__ method
input ENUM_APPLIED_PRICE ma_6b_price = PRICE_CLOSE;      //6b__ price
input int ma_6b_shift = 0;                               //6b__ shift
//input color ma_4b_clr = clrGreen;                        //4b__ color
//input int ma_4b_w = 1;                                   //4b__ width
//input ENUM_LINE_STYLE ma_4b_st = STYLE_SOLID;            //4b__ style
input int ma_6b_xperiod = 50;                            //6b__ crossover (if used)
//input int ma_4b_xw = 1;                                  //4b__ width
//input ENUM_LINE_STYLE ma_4b_xst = STYLE_DOT;             //4b__ style

input string sto_1b_note = "";                           //Stochastic 1b
input bool sto_1b_use = false;                           //1b__ use
input ENUM_TIMEFRAMES sto_1b_tf = PERIOD_CURRENT;        //1b__ tf
input int sto_1b_k_period = 15;                          //1b__ k period
input int sto_1b_d_period = 5;                           //1b__ d period
input int sto_1b_s_period = 3;                           //1b__ s period
input ENUM_MA_METHOD sto_1b_method = MODE_SMA;           //1b__ ma method
input ENUM_STO_PRICE sto_1b_price = STO_LOWHIGH;         //1b__ price
input bool sto_1b_inbetween = false;                     //1b__ limit to OB/OS range
input int sto_1b_ob = 80;                                //1b__ __ OB
input int sto_1b_os = 20;                                //1b__ __ OS

input string sto_2b_note = "";                           //Stochastic 2b
input bool sto_2b_use = false;                           //2b__ use
input ENUM_TIMEFRAMES sto_2b_tf = PERIOD_CURRENT;        //2b__ tf
input int sto_2b_k_period = 15;                          //2b__ k period
input int sto_2b_d_period = 5;                           //2b__ d period
input int sto_2b_s_period = 3;                           //2b__ s period
input ENUM_MA_METHOD sto_2b_method = MODE_SMA;           //2b__ ma method
input ENUM_STO_PRICE sto_2b_price = STO_LOWHIGH;         //2b__ price
input bool sto_2b_inbetween = false;                     //2b__ limit to OB/OS range
input int sto_2b_ob = 80;                                //2b__ __ OB
input int sto_2b_os = 20;                                //2b__ __ OS

input string sto_3b_note = "";                           //Stochastic 3b
input bool sto_3b_use = false;                           //3b__ use
input ENUM_TIMEFRAMES sto_3b_tf = PERIOD_CURRENT;        //3b__ tf
input int sto_3b_k_period = 15;                          //3b__ k period
input int sto_3b_d_period = 5;                           //3b__ d period
input int sto_3b_s_period = 3;                           //3b__ s period
input ENUM_MA_METHOD sto_3b_method = MODE_SMA;           //3b__ ma method
input ENUM_STO_PRICE sto_3b_price = STO_LOWHIGH;         //3b__ price
input bool sto_3b_inbetween = false;                     //3b__ limit to OB/OS range
input int sto_3b_ob = 80;                                //3b__ __ OB
input int sto_3b_os = 20;                                //3b__ __ OS

input string sto_4b_note = "";                           //Stochastic 4b
input bool sto_4b_use = false;                           //4b__ use
input ENUM_TIMEFRAMES sto_4b_tf = PERIOD_CURRENT;        //4b__ tf
input int sto_4b_k_period = 15;                          //4b__ k period
input int sto_4b_d_period = 5;                           //4b__ d period
input int sto_4b_s_period = 3;                           //4b__ s period
input ENUM_MA_METHOD sto_4b_method = MODE_SMA;           //4b__ ma method
input ENUM_STO_PRICE sto_4b_price = STO_LOWHIGH;         //4b__ price
input bool sto_4b_inbetween = false;                     //4b__ limit to OB/OS range
input int sto_4b_ob = 80;                                //4b__ __ OB
input int sto_4b_os = 20;                                //4b__ __ OS

input string sto_5b_note = "";                           //Stochastic 5b
input bool sto_5b_use = false;                           //5b__ use
input ENUM_TIMEFRAMES sto_5b_tf = PERIOD_CURRENT;        //5b__ tf
input int sto_5b_k_period = 15;                          //5b__ k period
input int sto_5b_d_period = 5;                           //5b__ d period
input int sto_5b_s_period = 3;                           //5b__ s period
input ENUM_MA_METHOD sto_5b_method = MODE_SMA;           //5b__ ma method
input ENUM_STO_PRICE sto_5b_price = STO_LOWHIGH;         //5b__ price
input bool sto_5b_inbetween = false;                     //5b__ limit to OB/OS range
input int sto_5b_ob = 80;                                //5b__ __ OB
input int sto_5b_os = 20;                                //5b__ __ OS


input string sto_6b_note = "";                           //Stochastic 6b
input bool sto_6b_use = false;                           //6b__ use
input ENUM_TIMEFRAMES sto_6b_tf = PERIOD_CURRENT;        //6b__ tf
input int sto_6b_k_period = 15;                          //6b__ k period
input int sto_6b_d_period = 5;                           //6b__ d period
input int sto_6b_s_period = 3;                           //6b__ s period
input ENUM_MA_METHOD sto_6b_method = MODE_SMA;           //6b__ ma method
input ENUM_STO_PRICE sto_6b_price = STO_LOWHIGH;         //6b__ price
input bool sto_6b_inbetween = false;                     //6b__ limit to OB/OS range
input int sto_6b_ob = 80;                                //6b__ __ OB
input int sto_6b_os = 20;                                //6b__ __ OS

input string macd_1_note_b ="---- B - MACD 1 ----";         //B_MACD_1
input bool macd_1_use_b = false;                            //__ use
input ENUM_TIMEFRAMES macd_1_tf_b = PERIOD_CURRENT;         //__ tf
input int macd_1_period_fast_b = 12;                        //__ fast period
input int macd_1_period_slow_b = 26;                        //__ slow period
input int macd_1_period_signal_b = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_1_price_b = PRICE_CLOSE;      //__ price

input string macd_2_note_b ="---- B - MACD 2 ----";         //B_MACD_2
input bool macd_2_use_b = false;                            //__ use
input ENUM_TIMEFRAMES macd_2_tf_b = PERIOD_CURRENT;         //__ tf
input int macd_2_period_fast_b = 12;                        //__ fast period
input int macd_2_period_slow_b = 26;                        //__ slow period
input int macd_2_period_signal_b = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_2_price_b = PRICE_CLOSE;      //__ price

input string macd_3_note_b ="---- B - MACD 3 ----";         //B_MACD_3
input bool macd_3_use_b = false;                            //__ use
input ENUM_TIMEFRAMES macd_3_tf_b = PERIOD_CURRENT;         //__ tf
input int macd_3_period_fast_b = 12;                        //__ fast period
input int macd_3_period_slow_b = 26;                        //__ slow period
input int macd_3_period_signal_b = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_3_price_b = PRICE_CLOSE;      //__ price

input string macd_4_note_b ="---- B - MACD 4 ----";         //B_MACD_4
input bool macd_4_use_b = false;                            //__ use
input ENUM_TIMEFRAMES macd_4_tf_b = PERIOD_CURRENT;         //__ tf
input int macd_4_period_fast_b = 12;                        //__ fast period
input int macd_4_period_slow_b = 26;                        //__ slow period
input int macd_4_period_signal_b = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_4_price_b = PRICE_CLOSE;      //__ price

input string macd_5_note_b ="---- B - MACD 5 ----";         //B_MACD_5
input bool macd_5_use_b = false;                            //__ use
input ENUM_TIMEFRAMES macd_5_tf_b = PERIOD_CURRENT;         //__ tf
input int macd_5_period_fast_b = 12;                        //__ fast period
input int macd_5_period_slow_b = 26;                        //__ slow period
input int macd_5_period_signal_b = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_5_price_b = PRICE_CLOSE;      //__ price

input string macd_6_note_b ="---- B - MACD 6 ----";         //B_MACD_6
input bool macd_6_use_b = false;                            //__ use
input ENUM_TIMEFRAMES macd_6_tf_b = PERIOD_CURRENT;         //__ tf
input int macd_6_period_fast_b = 12;                        //__ fast period
input int macd_6_period_slow_b = 26;                        //__ slow period
input int macd_6_period_signal_b = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_6_price_b = PRICE_CLOSE;      //__ price


input string note_seq_c = "---------- Sequence C ----------";//MA+STO Sequence C
input bool seqc_use = false;                             //__ use sequence C?

input string ma_1c_note = "";                            //MA 1c
input bool ma_1c_use = false;                            //1c__ use
input ENUM_TIMEFRAMES ma_1c_tf = PERIOD_CURRENT;         //1c__ tf
input int ma_1c_period = 30;                             //1c__ period
input ENUM_MA_METHOD ma_1c_method = MODE_EMA;            //1c__ method
input ENUM_APPLIED_PRICE ma_1c_price = PRICE_CLOSE;      //1c__ price
input int ma_1c_shift = 0;                               //1c__ shift
//input color ma_1b_clr = clrRoyalBlue;                    //1b__ color
//input int ma_1b_w = 1;                                   //1b__ width
//input ENUM_LINE_STYLE ma_1b_st = STYLE_SOLID;            //1b__ style
input int ma_1c_xperiod = 50;                            //1c__ crossover (if used)
//input int ma_1b_xw = 1;                                  //1b__ width
//input ENUM_LINE_STYLE ma_1b_xst = STYLE_DOT;             //1b__ style

input string ma_2c_note = "";                            //MA 2c
input bool ma_2c_use = false;                            //2c__ use
input ENUM_TIMEFRAMES ma_2c_tf = PERIOD_CURRENT;         //2c__ tf
input int ma_2c_period = 30;                             //2c__ period
input ENUM_MA_METHOD ma_2c_method = MODE_SMA;            //2c__ method
input ENUM_APPLIED_PRICE ma_2c_price = PRICE_CLOSE;      //2c__ price
input int ma_2c_shift = 0;                               //2c__ shift
//input color ma_2b_clr = clrOrange;                       //2b__ color
//input int ma_2b_w = 1;                                   //2b__ width
//input ENUM_LINE_STYLE ma_2b_st = STYLE_SOLID;            //2b__ style
input int ma_2c_xperiod = 50;                            //2c__ crossover (if used)
//input int ma_2b_xw = 1;                                  //2b__ width
//input ENUM_LINE_STYLE ma_2b_xst = STYLE_DOT;             //2b__ style

input string ma_3c_note = "";                            //MA 3c
input bool ma_3c_use = false;                            //3c__ use
input ENUM_TIMEFRAMES ma_3c_tf = PERIOD_CURRENT;         //3c__ tf
input int ma_3c_period = 30;                             //3c__ period
input ENUM_MA_METHOD ma_3c_method = MODE_SMA;            //3c__ method
input ENUM_APPLIED_PRICE ma_3c_price = PRICE_CLOSE;      //3c__ price
input int ma_3c_shift = 0;                               //3c__ shift
//input color ma_3b_clr = clrPink;                         //3b__ color
//input int ma_3b_w = 1;                                   //3b__ width
//input ENUM_LINE_STYLE ma_3b_st = STYLE_SOLID;            //3b__ style
input int ma_3c_xperiod = 50;                            //3c__ crossover (if used)
//input int ma_3b_xw = 1;                                  //3b__ width
//input ENUM_LINE_STYLE ma_3b_xst = STYLE_DOT;             //3b__ style

input string ma_4c_note = "";                            //MA 4c
input bool ma_4c_use = false;                            //4c__ use
input ENUM_TIMEFRAMES ma_4c_tf = PERIOD_CURRENT;         //4c__ tf
input int ma_4c_period = 30;                             //4c__ period
input ENUM_MA_METHOD ma_4c_method = MODE_SMA;            //4c__ method
input ENUM_APPLIED_PRICE ma_4c_price = PRICE_CLOSE;      //4c__ price
input int ma_4c_shift = 0;                               //4c__ shift
//input color ma_4b_clr = clrGreen;                        //4b__ color
//input int ma_4b_w = 1;                                   //4b__ width
//input ENUM_LINE_STYLE ma_4b_st = STYLE_SOLID;            //4b__ style
input int ma_4c_xperiod = 50;                            //4c__ crossover (if used)
//input int ma_4b_xw = 1;                                  //4b__ width
//input ENUM_LINE_STYLE ma_4b_xst = STYLE_DOT;             //4b__ style

input string ma_5c_note = "";                            //MA 5c
input bool ma_5c_use = false;                            //5c__ use
input ENUM_TIMEFRAMES ma_5c_tf = PERIOD_CURRENT;         //5c__ tf
input int ma_5c_period = 30;                             //5c__ period
input ENUM_MA_METHOD ma_5c_method = MODE_SMA;            //5c__ method
input ENUM_APPLIED_PRICE ma_5c_price = PRICE_CLOSE;      //5c__ price
input int ma_5c_shift = 0;                               //5c__ shift
//input color ma_4b_clr = clrGreen;                        //4b__ color
//input int ma_4b_w = 1;                                   //4b__ width
//input ENUM_LINE_STYLE ma_4b_st = STYLE_SOLID;            //4b__ style
input int ma_5c_xperiod = 50;                            //5c__ crossover (if used)
//input int ma_4b_xw = 1;                                  //4b__ width
//input ENUM_LINE_STYLE ma_4b_xst = STYLE_DOT;             //4b__ style


input string ma_6c_note = "";                            //MA 6c
input bool ma_6c_use = false;                            //6c__ use
input ENUM_TIMEFRAMES ma_6c_tf = PERIOD_CURRENT;         //6c__ tf
input int ma_6c_period = 30;                             //6c__ period
input ENUM_MA_METHOD ma_6c_method = MODE_SMA;            //6c__ method
input ENUM_APPLIED_PRICE ma_6c_price = PRICE_CLOSE;      //6c__ price
input int ma_6c_shift = 0;                               //6c__ shift
//input color ma_4b_clr = clrGreen;                        //4b__ color
//input int ma_4b_w = 1;                                   //4b__ width
//input ENUM_LINE_STYLE ma_4b_st = STYLE_SOLID;            //4b__ style
input int ma_6c_xperiod = 50;                            //6c__ crossover (if used)

input string sto_1c_note = "";                           //Stochastic 1c
input bool sto_1c_use = false;                           //1c__ use
input ENUM_TIMEFRAMES sto_1c_tf = PERIOD_CURRENT;        //1c__ tf
input int sto_1c_k_period = 15;                          //1c__ k period
input int sto_1c_d_period = 5;                           //1c__ d period
input int sto_1c_s_period = 3;                           //1c__ s period
input ENUM_MA_METHOD sto_1c_method = MODE_SMA;           //1c__ ma method
input ENUM_STO_PRICE sto_1c_price = STO_LOWHIGH;         //1c__ price
input bool sto_1c_inbetween = false;                     //1c__ limit to OB/OS range
input int sto_1c_ob = 80;                                //1c__ __ OB
input int sto_1c_os = 20;                                //1c__ __ OS

input string sto_2c_note = "";                           //Stochastic 2c
input bool sto_2c_use = false;                           //2c__ use
input ENUM_TIMEFRAMES sto_2c_tf = PERIOD_CURRENT;        //2c__ tf
input int sto_2c_k_period = 15;                          //2c__ k period
input int sto_2c_d_period = 5;                           //2c__ d period
input int sto_2c_s_period = 3;                           //2c__ s period
input ENUM_MA_METHOD sto_2c_method = MODE_SMA;           //2c__ ma method
input ENUM_STO_PRICE sto_2c_price = STO_LOWHIGH;         //2c__ price
input bool sto_2c_inbetween = false;                     //2c__ limit to OB/OS range
input int sto_2c_ob = 80;                                //2c__ __ OB
input int sto_2c_os = 20;                                //2c__ __ OS

input string sto_3c_note = "";                           //Stochastic 3c
input bool sto_3c_use = false;                           //3c__ use
input ENUM_TIMEFRAMES sto_3c_tf = PERIOD_CURRENT;        //3c__ tf
input int sto_3c_k_period = 15;                          //3c__ k period
input int sto_3c_d_period = 5;                           //3c__ d period
input int sto_3c_s_period = 3;                           //3c__ s period
input ENUM_MA_METHOD sto_3c_method = MODE_SMA;           //3c__ ma method
input ENUM_STO_PRICE sto_3c_price = STO_LOWHIGH;         //3c__ price
input bool sto_3c_inbetween = false;                     //3c__ limit to OB/OS range
input int sto_3c_ob = 80;                                //3c__ __ OB
input int sto_3c_os = 20;                                //3c__ __ OS

input string sto_4c_note = "";                           //Stochastic 4c
input bool sto_4c_use = false;                           //4c__ use
input ENUM_TIMEFRAMES sto_4c_tf = PERIOD_CURRENT;        //4c__ tf
input int sto_4c_k_period = 15;                          //4c__ k period
input int sto_4c_d_period = 5;                           //4c__ d period
input int sto_4c_s_period = 3;                           //4c__ s period
input ENUM_MA_METHOD sto_4c_method = MODE_SMA;           //4c__ ma method
input ENUM_STO_PRICE sto_4c_price = STO_LOWHIGH;         //4c__ price
input bool sto_4c_inbetween = false;                     //4c__ limit to OB/OS range
input int sto_4c_ob = 80;                                //4c__ __ OB
input int sto_4c_os = 20;                                //4c__ __ OS

input string sto_5c_note = "";                           //Stochastic 5c
input bool sto_5c_use = false;                           //5c__ use
input ENUM_TIMEFRAMES sto_5c_tf = PERIOD_CURRENT;        //5c__ tf
input int sto_5c_k_period = 15;                          //5c__ k period
input int sto_5c_d_period = 5;                           //5c__ d period
input int sto_5c_s_period = 3;                           //5c__ s period
input ENUM_MA_METHOD sto_5c_method = MODE_SMA;           //5c__ ma method
input ENUM_STO_PRICE sto_5c_price = STO_LOWHIGH;         //5c__ price
input bool sto_5c_inbetween = false;                     //5c__ limit to OB/OS range
input int sto_5c_ob = 80;                                //5c__ __ OB
input int sto_5c_os = 20;                                //5c__ __ OS


input string sto_6c_note = "";                           //Stochastic 6c
input bool sto_6c_use = false;                           //6c__ use
input ENUM_TIMEFRAMES sto_6c_tf = PERIOD_CURRENT;        //6c__ tf
input int sto_6c_k_period = 15;                          //6c__ k period
input int sto_6c_d_period = 5;                           //6c__ d period
input int sto_6c_s_period = 3;                           //6c__ s period
input ENUM_MA_METHOD sto_6c_method = MODE_SMA;           //6c__ ma method
input ENUM_STO_PRICE sto_6c_price = STO_LOWHIGH;         //6c__ price
input bool sto_6c_inbetween = false;                     //6c__ limit to OB/OS range
input int sto_6c_ob = 80;                                //6c__ __ OB
input int sto_6c_os = 20;                                //6c__ __ OS


input string macd_1_note_c ="---- C - MACD 1 ----";         //C_MACD_1
input bool macd_1_use_c = false;                            //__ use
input ENUM_TIMEFRAMES macd_1_tf_c = PERIOD_CURRENT;         //__ tf
input int macd_1_period_fast_c = 12;                        //__ fast period
input int macd_1_period_slow_c = 26;                        //__ slow period
input int macd_1_period_signal_c = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_1_price_c = PRICE_CLOSE;      //__ price

input string macd_2_note_c ="---- C - MACD 2 ----";         //C_MACD_2
input bool macd_2_use_c = false;                            //__ use
input ENUM_TIMEFRAMES macd_2_tf_c = PERIOD_CURRENT;         //__ tf
input int macd_2_period_fast_c = 12;                        //__ fast period
input int macd_2_period_slow_c = 26;                        //__ slow period
input int macd_2_period_signal_c = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_2_price_c = PRICE_CLOSE;      //__ price

input string macd_3_note_c ="---- C - MACD 3 ----";         //C_MACD_3
input bool macd_3_use_c = false;                            //__ use
input ENUM_TIMEFRAMES macd_3_tf_c = PERIOD_CURRENT;         //__ tf
input int macd_3_period_fast_c = 12;                        //__ fast period
input int macd_3_period_slow_c = 26;                        //__ slow period
input int macd_3_period_signal_c = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_3_price_c = PRICE_CLOSE;      //__ price

input string macd_4_note_c ="---- C - MACD 4 ----";         //C_MACD_4
input bool macd_4_use_c = false;                            //__ use
input ENUM_TIMEFRAMES macd_4_tf_c = PERIOD_CURRENT;         //__ tf
input int macd_4_period_fast_c = 12;                        //__ fast period
input int macd_4_period_slow_c = 26;                        //__ slow period
input int macd_4_period_signal_c = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_4_price_c = PRICE_CLOSE;      //__ price

input string macd_5_note_c ="---- C - MACD 5 ----";         //C_MACD_5
input bool macd_5_use_c = false;                            //__ use
input ENUM_TIMEFRAMES macd_5_tf_c = PERIOD_CURRENT;         //__ tf
input int macd_5_period_fast_c = 12;                        //__ fast period
input int macd_5_period_slow_c = 26;                        //__ slow period
input int macd_5_period_signal_c = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_5_price_c = PRICE_CLOSE;      //__ price

input string macd_6_note_c ="---- C - MACD 6 ----";         //C_MACD_6
input bool macd_6_use_c = false;                            //__ use
input ENUM_TIMEFRAMES macd_6_tf_c = PERIOD_CURRENT;         //__ tf
input int macd_6_period_fast_c = 12;                        //__ fast period
input int macd_6_period_slow_c = 26;                        //__ slow period
input int macd_6_period_signal_c = 9;                       //__ signal period
input ENUM_APPLIED_PRICE macd_6_price_c = PRICE_CLOSE;      //__ price

input string pivot_note = "";                            //Pivot
input bool piv_show = false;                             //__ show
input color piv_r_clr = clrFireBrick;                    //__ r line color
input color piv_p_clr = clrDarkGoldenrod;                //__ p line color
input color piv_s_clr = clrGreen;                        //__ s line color
input bool piv_dis_on = false;                           //__ use distance limits (show must =T)
input int piv_dis_pips_from = 5;                         //__ pips, away from
input int piv_dis_pips_to = 5;                           //__ pips, towards
input bool piv_show_text = true;                         //__ show level texts
input int piv_fsize = 14;                                //__ __ font size
input int piv_text_offset = 10;                          //__ __ offset (bars right of live)
input color piv_text_clr_r = clrFireBrick;               //__ __ r color
input color piv_text_clr_p = clrDarkGoldenrod;           //__ __ p color
input color piv_text_clr_s = clrGreen;                   //__ __ s color
input bool piv_rect = false;                             //__ show distance rects
input color piv_rect_clr_r = clrFireBrick;               //__ __ r color
input color piv_rect_clr_p = clrDarkGoldenrod;           //__ __ p color
input color piv_rect_clr_s = clrGreen;                   //__ __ s color

input string alert_note = "";                            //Alerts
input bool alert_pop = false;                            //__ popup
input bool alert_push = false;                           //__ push

CTrade  trade;
/*double pivot_prices[];
datetime pivot_times[];
double res1_prices[];
datetime res1_times[];
double res2_prices[];
datetime res2_times[];
double res3_prices[];
datetime res3_times[];
double sup1_prices[];
datetime sup1_times[];
double sup2_prices[];
datetime sup2_times[];
double sup3_prices[];
datetime sup3_times[];*/
int MagicNumber;
double pips;
int total_bars;
int sum_trades=0;
datetime lastTime = 0;

double      MA1[],MA2[],MA3[],MA4[],MA5[],MA6[];
double      MA1b[],MA2b[],MA3b[],MA4b[],MA5b[],MA6b[];
double      MA1c[],MA2c[],MA3c[],MA4c[],MA5c[],MA6c[];
double      MAX1[],MAX2[],MAX3[],MAX4[],MAX5[],MAX6[];
double      MAX1b[],MAX2b[],MAX3b[],MAX4b[],MAX5b[],MAX6b[];
double      MAX1c[],MAX2c[],MAX3c[],MAX4c[],MAX5c[],MAX6c[];
int         MA_handle1,MA_handle2,MA_handle3,MA_handle4,MA_handle5,MA_handle6;
int         MA_handle1b,MA_handle2b,MA_handle3b,MA_handle4b,MA_handle5b,MA_handle6b;
int         MA_handle1c,MA_handle2c,MA_handle3c,MA_handle4c,MA_handle5c,MA_handle6c;
int         MA_xhandle1,MA_xhandle2,MA_xhandle3,MA_xhandle4,MA_xhandle5,MA_xhandle6;
int         MA_xhandle1b,MA_xhandle2b,MA_xhandle3b,MA_xhandle4b,MA_xhandle5b,MA_xhandle6b;
int         MA_xhandle1c,MA_xhandle2c,MA_xhandle3c,MA_xhandle4c,MA_xhandle5c,MA_xhandle6c;
double      StochM1[],StochM2[],StochM3[],StochM4[],StochM5[],StochM6[];
double      StochM1b[],StochM2b[],StochM3b[],StochM4b[],StochM5b[],StochM6b[];
double      StochM1c[],StochM2c[],StochM3c[],StochM4c[],StochM5c[],StochM6c[];
double      StochS1[],StochS2[],StochS3[],StochS4[],StochS5[],StochS6[];
double      StochS1b[],StochS2b[],StochS3b[],StochS4b[],StochS5b[],StochS6b[];
double      StochS1c[],StochS2c[],StochS3c[],StochS4c[],StochS5c[],StochS6c[];
int         Stoch_handle1,Stoch_handle2,Stoch_handle3,Stoch_handle4,Stoch_handle5,Stoch_handle6;
int         Stoch_handle1b,Stoch_handle2b,Stoch_handle3b,Stoch_handle4b,Stoch_handle5b,Stoch_handle6b;
int         Stoch_handle1c,Stoch_handle2c,Stoch_handle3c,Stoch_handle4c,Stoch_handle5c,Stoch_handle6c;

int handle_macd_1;
int handle_macd_2;
int handle_macd_3;
int handle_macd_4;
int handle_macd_5;
int handle_macd_6;

double macd_main_buff_1[];
double macd_main_buff_2[];
double macd_main_buff_3[];
double macd_main_buff_4[];
double macd_main_buff_5[];
double macd_main_buff_6[];

double macd_signal_buff_1[];
double macd_signal_buff_2[];
double macd_signal_buff_3[];
double macd_signal_buff_4[];
double macd_signal_buff_5[];
double macd_signal_buff_6[];

int handle_macd_1_b;
int handle_macd_2_b;
int handle_macd_3_b;
int handle_macd_4_b;
int handle_macd_5_b;
int handle_macd_6_b;

double macd_main_buff_1_b[];
double macd_main_buff_2_b[];
double macd_main_buff_3_b[];
double macd_main_buff_4_b[];
double macd_main_buff_5_b[];
double macd_main_buff_6_b[];

double macd_signal_buff_1_b[];
double macd_signal_buff_2_b[];
double macd_signal_buff_3_b[];
double macd_signal_buff_4_b[];
double macd_signal_buff_5_b[];
double macd_signal_buff_6_b[];

double p_buff[];
double ps1_buff[];
double ps2_buff[];
double ps3_buff[];
double pr1_buff[];
double pr2_buff[];
double pr3_buff[];

int pivot_handle;

int handle_macd_1_c;
int handle_macd_2_c;
int handle_macd_3_c;
int handle_macd_4_c;
int handle_macd_5_c;
int handle_macd_6_c;

double macd_main_buff_1_c[];
double macd_main_buff_2_c[];
double macd_main_buff_3_c[];
double macd_main_buff_4_c[];
double macd_main_buff_5_c[];
double macd_main_buff_6_c[];

double macd_signal_buff_1_c[];
double macd_signal_buff_2_c[];
double macd_signal_buff_3_c[];
double macd_signal_buff_4_c[];
double macd_signal_buff_5_c[];
double macd_signal_buff_6_c[];

int         custom_handle;
string symbols[];
double price2pip;
string tag;


int OnInit()
  {
//---
  /* ArrayResize(pivot_prices,1);   pivot_prices[0] = 0;
   ArrayResize(pivot_times,1);   pivot_times[0] = 0;
   ArrayResize(res1_prices,1);   res1_prices[0] = 0;
   ArrayResize(res1_times,1);   res1_times[0] = 0;
   ArrayResize(res2_prices,1);   res2_prices[0] = 0;
   ArrayResize(res2_times,1);   res2_times[0] = 0;
   ArrayResize(res3_prices,1);   res3_prices[0] = 0;
   ArrayResize(res3_times,1);   res3_times[0] = 0;
   ArrayResize(sup1_prices,1);   sup1_prices[0] = 0;
   ArrayResize(sup1_times,1);   sup1_times[0] = 0;
   ArrayResize(sup2_prices,1);   sup2_prices[0] = 0;
   ArrayResize(sup2_times,1);   sup2_times[0] = 0;
   ArrayResize(sup3_prices,1);   sup3_prices[0] = 0;
   ArrayResize(sup3_times,1);   sup3_times[0] = 0;*/

   int bars = Bars(Symbol(),PERIOD_CURRENT);
   /*ArrayResize(p_buff,bars);
   ArrayResize(ps1_buff,bars);
   ArrayResize(ps2_buff,bars);
   ArrayResize(ps3_buff,bars);
   ArrayResize(pr1_buff,bars);
   ArrayResize(pr2_buff,bars);
   ArrayResize(pr3_buff,bars);*/
   
   //updatePivots(true);

  tag = "YBM_Signaller_";
   price2pip = _Point*pip_adjust_10*10;//pip_adjust_10=1 and *10 here by default, 3/5 digit fx pricing is standard

   MagicNumber=64983;
   trade.SetExpertMagicNumber(MagicNumber);
//--- set available slippage in points when buying/selling
   int deviation=10;
   trade.SetDeviationInPoints(deviation);
//--- order filling mode, the mode allowed by the server should be used
   trade.SetTypeFilling(ORDER_FILLING_RETURN);
//--- logging mode: it would be better not to declare this method at all, the class will set the best mode on its own
   //trade.LogLevel(1); 
//--- what function is to be used for trading: true - OrderSendAsync(), false - OrderSend()
   trade.SetAsyncMode(false);
   
   int count = StringSplit(pairs,StringGetCharacter(",",0),symbols);
       
      
   MA_handle1 = iMA(symbols[0],ma_1_tf,ma_1_period,ma_1_shift,ma_1_method,ma_1_price);
   MA_handle2 = iMA(symbols[0],ma_2_tf,ma_2_period,ma_2_shift,ma_2_method,ma_2_price);
   MA_handle3 = iMA(symbols[0],ma_3_tf,ma_3_period,ma_3_shift,ma_3_method,ma_3_price);
   MA_handle4 = iMA(symbols[0],ma_4_tf,ma_4_period,ma_4_shift,ma_4_method,ma_4_price);
   MA_handle5 = iMA(symbols[0],ma_5_tf,ma_5_period,ma_5_shift,ma_5_method,ma_5_price);
   MA_handle6 = iMA(symbols[0],ma_6_tf,ma_6_period,ma_6_shift,ma_6_method,ma_6_price);
   
   if(ma_crossover){
   
   MA_xhandle1 = iMA(symbols[0],ma_1_tf,ma_1_xperiod,ma_1_shift,ma_1_method,ma_1_price);
   MA_xhandle2 = iMA(symbols[0],ma_2_tf,ma_2_xperiod,ma_2_shift,ma_2_method,ma_2_price);
   MA_xhandle3 = iMA(symbols[0],ma_3_tf,ma_3_xperiod,ma_3_shift,ma_3_method,ma_3_price);
   MA_xhandle4 = iMA(symbols[0],ma_4_tf,ma_4_xperiod,ma_4_shift,ma_4_method,ma_4_price);
   MA_xhandle5 = iMA(symbols[0],ma_5_tf,ma_5_xperiod,ma_5_shift,ma_5_method,ma_5_price);
   MA_xhandle6 = iMA(symbols[0],ma_6_tf,ma_6_xperiod,ma_6_shift,ma_6_method,ma_6_price);
   
   }
   
   Stoch_handle1 = iStochastic(symbols[0],sto_1_tf,sto_1_k_period,sto_1_d_period,sto_1_s_period,sto_1_method,sto_1_price);
   Stoch_handle2 = iStochastic(symbols[0],sto_2_tf,sto_2_k_period,sto_2_d_period,sto_2_s_period,sto_2_method,sto_2_price);
   Stoch_handle3 = iStochastic(symbols[0],sto_3_tf,sto_3_k_period,sto_3_d_period,sto_3_s_period,sto_3_method,sto_3_price);
   Stoch_handle4 = iStochastic(symbols[0],sto_4_tf,sto_4_k_period,sto_4_d_period,sto_4_s_period,sto_4_method,sto_4_price);
   Stoch_handle5 = iStochastic(symbols[0],sto_5_tf,sto_5_k_period,sto_5_d_period,sto_5_s_period,sto_5_method,sto_5_price);
   Stoch_handle6 = iStochastic(symbols[0],sto_6_tf,sto_6_k_period,sto_6_d_period,sto_6_s_period,sto_6_method,sto_6_price);
   
   handle_macd_1 = iMACD(symbols[0],macd_1_tf,macd_1_period_fast,macd_1_period_slow,macd_1_period_signal,macd_1_price);
   handle_macd_2 = iMACD(symbols[0],macd_2_tf,macd_2_period_fast,macd_2_period_slow,macd_2_period_signal,macd_2_price);
   handle_macd_3 = iMACD(symbols[0],macd_3_tf,macd_3_period_fast,macd_3_period_slow,macd_3_period_signal,macd_3_price);
   handle_macd_4 = iMACD(symbols[0],macd_4_tf,macd_4_period_fast,macd_4_period_slow,macd_4_period_signal,macd_4_price);
   handle_macd_5 = iMACD(symbols[0],macd_5_tf,macd_5_period_fast,macd_5_period_slow,macd_5_period_signal,macd_5_price);
   handle_macd_6 = iMACD(symbols[0],macd_6_tf,macd_6_period_fast,macd_6_period_slow,macd_6_period_signal,macd_6_price);
   
   if(seqb_use){
   
   MA_handle1b = iMA(symbols[0],ma_1b_tf,ma_1b_period,ma_1b_shift,ma_1b_method,ma_1b_price);
   MA_handle2b = iMA(symbols[0],ma_2b_tf,ma_2b_period,ma_2b_shift,ma_2b_method,ma_2b_price);
   MA_handle3b = iMA(symbols[0],ma_3b_tf,ma_3b_period,ma_3b_shift,ma_3b_method,ma_3b_price);
   MA_handle4b = iMA(symbols[0],ma_4b_tf,ma_4b_period,ma_4b_shift,ma_4b_method,ma_4b_price);
   MA_handle5b = iMA(symbols[0],ma_5b_tf,ma_5b_period,ma_5b_shift,ma_5b_method,ma_5b_price);
   MA_handle6b = iMA(symbols[0],ma_6b_tf,ma_6b_period,ma_6b_shift,ma_6b_method,ma_6b_price);
   
   if(ma_crossover){
   
   MA_xhandle1b = iMA(symbols[0],ma_1b_tf,ma_1b_xperiod,ma_1b_shift,ma_1b_method,ma_1b_price);
   MA_xhandle2b = iMA(symbols[0],ma_2b_tf,ma_2b_xperiod,ma_2b_shift,ma_2b_method,ma_2b_price);
   MA_xhandle3b = iMA(symbols[0],ma_3b_tf,ma_3b_xperiod,ma_3b_shift,ma_3b_method,ma_3b_price);
   MA_xhandle4b = iMA(symbols[0],ma_4b_tf,ma_4b_xperiod,ma_4b_shift,ma_4b_method,ma_4b_price);
   MA_xhandle5b = iMA(symbols[0],ma_5b_tf,ma_5b_xperiod,ma_5b_shift,ma_5b_method,ma_5b_price);
   MA_xhandle6b = iMA(symbols[0],ma_6b_tf,ma_6b_xperiod,ma_6b_shift,ma_6b_method,ma_6b_price);
   
   }
   
   Stoch_handle1b = iStochastic(symbols[0],sto_1b_tf,sto_1b_k_period,sto_1b_d_period,sto_1b_s_period,sto_1b_method,sto_1b_price);
   Stoch_handle2b = iStochastic(symbols[0],sto_2b_tf,sto_2b_k_period,sto_2b_d_period,sto_2b_s_period,sto_2b_method,sto_2b_price);
   Stoch_handle3b = iStochastic(symbols[0],sto_3b_tf,sto_3b_k_period,sto_3b_d_period,sto_3b_s_period,sto_3b_method,sto_3b_price);
   Stoch_handle4b = iStochastic(symbols[0],sto_4b_tf,sto_4b_k_period,sto_4b_d_period,sto_4b_s_period,sto_4b_method,sto_4b_price);
   Stoch_handle5b = iStochastic(symbols[0],sto_5b_tf,sto_5b_k_period,sto_5b_d_period,sto_5b_s_period,sto_5b_method,sto_5b_price);
   Stoch_handle6b = iStochastic(symbols[0],sto_6b_tf,sto_6b_k_period,sto_6b_d_period,sto_6b_s_period,sto_6b_method,sto_6b_price);
   
   handle_macd_1_b = iMACD(symbols[0],macd_1_tf_b,macd_1_period_fast_b,macd_1_period_slow_b,macd_1_period_signal_b,macd_1_price_b);
   handle_macd_2_b = iMACD(symbols[0],macd_2_tf_b,macd_2_period_fast_b,macd_2_period_slow_b,macd_2_period_signal_b,macd_2_price_b);
   handle_macd_3_b = iMACD(symbols[0],macd_3_tf_b,macd_3_period_fast_b,macd_3_period_slow_b,macd_3_period_signal_b,macd_3_price_b);
   handle_macd_4_b = iMACD(symbols[0],macd_4_tf_b,macd_4_period_fast_b,macd_4_period_slow_b,macd_4_period_signal_b,macd_4_price_b);
   handle_macd_5_b = iMACD(symbols[0],macd_5_tf_b,macd_5_period_fast_b,macd_5_period_slow_b,macd_5_period_signal_b,macd_5_price_b);
   handle_macd_6_b = iMACD(symbols[0],macd_6_tf_b,macd_6_period_fast_b,macd_6_period_slow_b,macd_6_period_signal_b,macd_6_price_b);
   
   }
   
   
   if(seqc_use){
   
   MA_handle1c = iMA(symbols[0],ma_1c_tf,ma_1c_period,ma_1c_shift,ma_1c_method,ma_1c_price);
   MA_handle2c = iMA(symbols[0],ma_2c_tf,ma_2c_period,ma_2c_shift,ma_2c_method,ma_2c_price);
   MA_handle3c = iMA(symbols[0],ma_3c_tf,ma_3c_period,ma_3c_shift,ma_3c_method,ma_3c_price);
   MA_handle4c = iMA(symbols[0],ma_4c_tf,ma_4c_period,ma_4c_shift,ma_4c_method,ma_4c_price);
   MA_handle5c = iMA(symbols[0],ma_5c_tf,ma_5c_period,ma_5c_shift,ma_5c_method,ma_5c_price);
   MA_handle6c = iMA(symbols[0],ma_6c_tf,ma_6c_period,ma_6c_shift,ma_6c_method,ma_6c_price);
   
   if(ma_crossover){
   
   MA_xhandle1c = iMA(symbols[0],ma_1c_tf,ma_1c_xperiod,ma_1c_shift,ma_1c_method,ma_1c_price);
   MA_xhandle2c = iMA(symbols[0],ma_2c_tf,ma_2c_xperiod,ma_2c_shift,ma_2c_method,ma_2c_price);
   MA_xhandle3c = iMA(symbols[0],ma_3c_tf,ma_3c_xperiod,ma_3c_shift,ma_3c_method,ma_3c_price);
   MA_xhandle4c = iMA(symbols[0],ma_4c_tf,ma_4c_xperiod,ma_4c_shift,ma_4c_method,ma_4c_price);
   MA_xhandle5c = iMA(symbols[0],ma_5c_tf,ma_5c_xperiod,ma_5c_shift,ma_5c_method,ma_5c_price);
   MA_xhandle6c = iMA(symbols[0],ma_6c_tf,ma_6c_xperiod,ma_6c_shift,ma_6c_method,ma_6c_price);
   
   }
   
   Stoch_handle1c = iStochastic(symbols[0],sto_1c_tf,sto_1c_k_period,sto_1c_d_period,sto_1c_s_period,sto_1c_method,sto_1c_price);
   Stoch_handle2c = iStochastic(symbols[0],sto_2c_tf,sto_2c_k_period,sto_2c_d_period,sto_2c_s_period,sto_2c_method,sto_2c_price);
   Stoch_handle3c = iStochastic(symbols[0],sto_3c_tf,sto_3c_k_period,sto_3c_d_period,sto_3c_s_period,sto_3c_method,sto_3c_price);
   Stoch_handle4c = iStochastic(symbols[0],sto_4c_tf,sto_4c_k_period,sto_4c_d_period,sto_4c_s_period,sto_4c_method,sto_4c_price);
   Stoch_handle5c = iStochastic(symbols[0],sto_5c_tf,sto_5c_k_period,sto_5c_d_period,sto_5c_s_period,sto_5c_method,sto_5c_price);
   Stoch_handle6c = iStochastic(symbols[0],sto_6c_tf,sto_6c_k_period,sto_6c_d_period,sto_6c_s_period,sto_6c_method,sto_6c_price);
   
   handle_macd_1_c = iMACD(symbols[0],macd_1_tf_c,macd_1_period_fast_c,macd_1_period_slow_c,macd_1_period_signal_c,macd_1_price_c);
   handle_macd_2_c = iMACD(symbols[0],macd_2_tf_c,macd_2_period_fast_c,macd_2_period_slow_c,macd_2_period_signal_c,macd_2_price_c);
   handle_macd_3_c = iMACD(symbols[0],macd_3_tf_c,macd_3_period_fast_c,macd_3_period_slow_c,macd_3_period_signal_c,macd_3_price_c);
   handle_macd_4_c = iMACD(symbols[0],macd_4_tf_c,macd_4_period_fast_c,macd_4_period_slow_c,macd_4_period_signal_c,macd_4_price_c);
   handle_macd_5_c = iMACD(symbols[0],macd_5_tf_c,macd_5_period_fast_c,macd_5_period_slow_c,macd_5_period_signal_c,macd_5_price_c);
   handle_macd_6_c = iMACD(symbols[0],macd_6_tf_c,macd_6_period_fast_c,macd_6_period_slow_c,macd_6_period_signal_c,macd_6_price_c);
   
   }
   
   if(piv_show || piv_dis_on){
   /*custom_handle = iCustom(Symbol(),PERIOD_CURRENT,"YBM_Signaller_Pivot_Lines",history_bars,pip_adjust_10,"",true,piv_r_clr,piv_p_clr,piv_s_clr,piv_dis_on,
   piv_dis_pips_from,piv_dis_pips_to,piv_show_text,piv_fsize,piv_text_offset,piv_text_clr_r,piv_text_clr_p,piv_text_clr_s,
   piv_rect,piv_rect_clr_r,piv_rect_clr_p,piv_rect_clr_s);*/
   
 //} 
 
   //if(piv_dis_on){
   
     pivot_handle = iCustom(symbols[0],PERIOD_CURRENT,"YBM_Signaller_Pivot_Lines",history_bars,pip_adjust_10,"",true,piv_r_clr,piv_p_clr,piv_s_clr,piv_dis_on,
   piv_dis_pips_from,piv_dis_pips_to,piv_show_text,piv_fsize,piv_text_offset,piv_text_clr_r,piv_text_clr_p,piv_text_clr_s,
   piv_rect,piv_rect_clr_r,piv_rect_clr_p,piv_rect_clr_s);
   if(piv_show)ChartIndicatorAdd(0,0,pivot_handle);
   
      if(pivot_handle<0){
      
         Print("Creation of indicator handle failed.");
       return (-1);
      }
   }
   
   
 
   if(MA_handle1<0||MA_handle2<0||MA_handle3<0||MA_handle4<0||MA_handle5<0||MA_handle6<0||Stoch_handle1<0||Stoch_handle2<0||Stoch_handle3<0||Stoch_handle4<0||Stoch_handle5<0||Stoch_handle6<0||
     handle_macd_1<0||handle_macd_2<0||handle_macd_3<0||handle_macd_4<0||handle_macd_5<0||handle_macd_6<0)
     {
       Print("Creation of indicator handle failed.");
       return (-1);
     
     }
     
     if(ma_crossover&&(MA_xhandle1<0||MA_xhandle2<0||MA_xhandle3<0||MA_xhandle4<0||MA_xhandle5<0||MA_xhandle6<0)){
    
       Print("Creation of indicator handle failed.");
       return (-1);
    }
     
   if(seqb_use) {
   if(MA_handle1b<0||MA_handle2b<0||MA_handle3b<0||MA_handle4b<0||MA_handle5b<0||MA_handle6b<0||Stoch_handle1b<0||Stoch_handle2b<0||Stoch_handle3b<0||Stoch_handle4b<0||Stoch_handle5b<0||Stoch_handle6b<0||
     handle_macd_1_b<0||handle_macd_2_b<0||handle_macd_3_b<0||handle_macd_4_b<0||handle_macd_5_b<0||handle_macd_6_b<0)
     {
       Print("Creation of indicator handle failed.");
       return (-1);
     
     }
     
    if(ma_crossover&&(MA_xhandle1b<0||MA_xhandle2b<0||MA_xhandle3b<0||MA_xhandle4b<0||MA_xhandle5b<0||MA_xhandle6b<0)){
    
       Print("Creation of indicator handle failed.");
       return (-1);
    }
   }
   
   if(seqc_use) {
   if(MA_handle1c<0||MA_handle2c<0||MA_handle3c<0||MA_handle4c<0||MA_handle5c<0||MA_handle6c<0||Stoch_handle1c<0||Stoch_handle2c<0||Stoch_handle3c<0||Stoch_handle4c<0||Stoch_handle5c<0||Stoch_handle6c<0||
     handle_macd_1_c<0||handle_macd_2_c<0||handle_macd_3_c<0||handle_macd_4_c<0||handle_macd_5_c<0||handle_macd_6_c<0)
     {
       Print("Creation of indicator handle failed.");
       return (-1);
     
     }
     
    if(ma_crossover&&(MA_xhandle1c<0||MA_xhandle2c<0||MA_xhandle3c<0||MA_xhandle4c<0||MA_xhandle5c<0||MA_xhandle6c<0)){
    
       Print("Creation of indicator handle failed.");
       return (-1);
    }
   }
    
    total_bars = Bars(Symbol(),PERIOD_CURRENT);
    cond_list_make();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectsDeleteAll(0,tag,-1,-1);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   //updatePivots();
   trailing();
    if(TimeToString(TimeCurrent(),TIME_MINUTES)<start_time||TimeToString(TimeCurrent(),TIME_MINUTES)>stop_time){
      sum_trades = 0;
    return;}
    
     if(entry_option==1&&!isNewCandle())return;
    
      for(int x = 0; x < ArraySize(symbols); x++){
    
   //plotLines(symbols[x],true);  
   // plotLines(symbols[x]);
    
    if(checkSignal(symbols[x],0)&&totalOrders()<max_trades&&sum_trades<total_trades)
      placeOrder(symbols[x],0,x);
    if(checkSignal(symbols[x],1)&&totalOrders()<max_trades&&sum_trades<total_trades)
      placeOrder(symbols[x],1,x);
      
    if(seqb_use&&checkSignalB(symbols[x],0)&&totalOrders()<max_trades&&sum_trades<total_trades)
      placeOrder(symbols[x],0,x);
    if(seqb_use&&checkSignalB(symbols[x],1)&&totalOrders()<max_trades&&sum_trades<total_trades)
      placeOrder(symbols[x],1,x);
      
    if(seqc_use&&checkSignalC(symbols[x],0)&&totalOrders()<max_trades&&sum_trades<total_trades)
      placeOrder(symbols[x],0,x);
    if(seqc_use&&checkSignalC(symbols[x],1)&&totalOrders()<max_trades&&sum_trades<total_trades)
      placeOrder(symbols[x],1,x);
      
    }
  }
//+------------------------------------------------------------------+
/*
void plotLines(string symbol,bool first = false){

  static double last_pivot = 0;
  static double last_res1 = 0;
  static double last_res2 = 0;
  static double last_res3 = 0;
  static double last_sup1 = 0;
  static double last_sup2 = 0;
  static double last_sup3 = 0;
  
  int limit_p = 0;
    if(first)limit_p = history_bars;
    
   for(int i = limit_p; i>=0; i--){
   
         static int day_p;
         static double ph;
         static double pl;
         static double pc;  
         
       MqlDateTime time_p;
       TimeToStruct(iTime(symbol,PERIOD_CURRENT,i),time_p);
      
      if(i==limit_p && first){
            day_p = time_p.day_of_week;
            ph = iOpen(symbol,PERIOD_CURRENT,i);
            pl = iOpen(symbol,PERIOD_CURRENT,i);
         }
         
       if(time_p.day_of_week != day_p && time_p.day_of_week!=6 && time_p.day_of_week!=0){
            day_p = time_p.day_of_week;
            pc = iClose(symbol,PERIOD_CURRENT,i+1);
            
            if(last_pivot != (ph+pl+pc)/3.0){
            
              if(!(i==limit_p&&first)){
              
                arrayPush(pivot_prices,last_pivot);
                arrayPush(pivot_times,iTime(symbol,PERIOD_CURRENT,i+1));
              }
              
              last_pivot = (ph+pl+pc)/3.0;
              arrayPush(pivot_prices,last_pivot);
              arrayPush(pivot_times,iTime(symbol,PERIOD_CURRENT,i));
            }
            
            if(last_res1 != 2*last_pivot - pl){
            
              if(!(i==limit_p&&first)){
              
                arrayPush(res1_prices,last_res1);
                arrayPush(res1_times,iTime(symbol,PERIOD_CURRENT,i+1));
              }
              
              last_res1 = 2*last_pivot - pl;
              arrayPush(res1_prices,last_res1);
              arrayPush(res1_times,iTime(symbol,PERIOD_CURRENT,i));
            }
            
            if(last_sup1 != 2*last_pivot - ph){
            
              if(!(i==limit_p&&first)){
              
                arrayPush(sup1_prices,last_sup1);
                arrayPush(sup1_times,iTime(symbol,PERIOD_CURRENT,i+1));
              }
              
              last_sup1 = 2*last_pivot - ph;
              arrayPush(sup1_prices,last_sup1);
              arrayPush(sup1_times,iTime(symbol,PERIOD_CURRENT,i));
            }
            
            if(last_res2 != last_pivot + (ph-pl)){
            
              if(!(i==limit_p&&first)){
              
                arrayPush(res2_prices,last_res2);
                arrayPush(res2_times,iTime(symbol,PERIOD_CURRENT,i+1));
              }
              
              last_res2 = last_pivot + (ph-pl);
              arrayPush(res2_prices,last_res2);
              arrayPush(res2_times,iTime(symbol,PERIOD_CURRENT,i));
            }
            
            if(last_sup2 != last_pivot - (ph-pl)){
            
              if(!(i==limit_p&&first)){
              
                arrayPush(sup2_prices,last_sup2);
                arrayPush(sup2_times,iTime(symbol,PERIOD_CURRENT,i+1));
              }
              
              last_sup2 = last_pivot - (ph-pl);
              arrayPush(sup2_prices,last_sup2);
              arrayPush(sup2_times,iTime(symbol,PERIOD_CURRENT,i));
            }
            
            if(last_res3 != ph + 2*(last_pivot-pl)){
            
              if(!(i==limit_p&&first)){
              
                arrayPush(res3_prices,last_res3);
                arrayPush(res3_times,iTime(symbol,PERIOD_CURRENT,i+1));
              }
              
              last_res3 = ph + 2*(last_pivot-pl);
              arrayPush(res3_prices,last_res3);
              arrayPush(res3_times,iTime(symbol,PERIOD_CURRENT,i));
            }
            
            if(last_sup3 != pl - 2*(ph-last_pivot)){
            
              if(!(i==limit_p&&first)){
              
                arrayPush(sup3_prices,last_sup3);
                arrayPush(sup3_times,iTime(symbol,PERIOD_CURRENT,i+1));
              }
              
              last_sup3 = pl - 2*(ph-last_pivot);
              arrayPush(sup3_prices,last_sup3);
              arrayPush(sup3_times,iTime(symbol,PERIOD_CURRENT,i));
            }
            ph = iOpen(symbol,PERIOD_CURRENT,i);
            pl = iOpen(symbol,PERIOD_CURRENT,i);
      }
      
      if(iHigh(symbol,PERIOD_CURRENT,i) > ph)ph = iHigh(symbol,PERIOD_CURRENT,i);
         if(iLow(symbol,PERIOD_CURRENT,i) < pl)pl = iLow(symbol,PERIOD_CURRENT,i);
   }
}  */

void arrayPush(double & array[], double dataToPush)
  {
   int count = ArrayResize(array, ArraySize(array) + 1);
   array[ArraySize(array) - 1] = dataToPush;
  }
  
 void arrayPush(datetime & array[], datetime dataToPush)
  {
   int count = ArrayResize(array, ArraySize(array) + 1);
   array[ArraySize(array) - 1] = dataToPush;
  }
  
bool CopyBufferAsSeries(
                        int handle,      // indicator's handle
                        int bufer,       // buffer index
                        int start,       // start index
                        int number,      // number of elements to copy
                        bool asSeries,   // if it's true, the elements will be indexed as series
                        double &M[]      // target array
                        )
  {
//--- filling the array M with current values of the indicator
   if(CopyBuffer(handle,bufer,start,number,M)<=0) return(false);
//--- the elements will be indexed as follows:
//--- if asSeries=true, it will be indexed as timeseries
//--- if asSeries=false, it will be indexed as default
   ArraySetAsSeries(M,asSeries);
//---
   return(true);
  }
  
bool checkSignal(string symbol, int type){

    double close = iClose(symbol,PERIOD_CURRENT,entry_option);
    
    MA_handle1 = iMA(symbol,ma_1_tf,ma_1_period,ma_1_shift,ma_1_method,ma_1_price);
   MA_handle2 = iMA(symbol,ma_2_tf,ma_2_period,ma_2_shift,ma_2_method,ma_2_price);
   MA_handle3 = iMA(symbol,ma_3_tf,ma_3_period,ma_3_shift,ma_3_method,ma_3_price);
   MA_handle4 = iMA(symbol,ma_4_tf,ma_4_period,ma_4_shift,ma_4_method,ma_4_price);
   MA_handle5 = iMA(symbol,ma_5_tf,ma_5_period,ma_5_shift,ma_5_method,ma_5_price);
   MA_handle6 = iMA(symbol,ma_6_tf,ma_6_period,ma_6_shift,ma_6_method,ma_6_price);
   
   if(ma_crossover){
   
   MA_xhandle1 = iMA(symbol,ma_1_tf,ma_1_xperiod,ma_1_shift,ma_1_method,ma_1_price);
   MA_xhandle2 = iMA(symbol,ma_2_tf,ma_2_xperiod,ma_2_shift,ma_2_method,ma_2_price);
   MA_xhandle3 = iMA(symbol,ma_3_tf,ma_3_xperiod,ma_3_shift,ma_3_method,ma_3_price);
   MA_xhandle4 = iMA(symbol,ma_4_tf,ma_4_xperiod,ma_4_shift,ma_4_method,ma_4_price);
   MA_xhandle5 = iMA(symbol,ma_5_tf,ma_5_xperiod,ma_5_shift,ma_5_method,ma_5_price);
   MA_xhandle6 = iMA(symbol,ma_6_tf,ma_6_xperiod,ma_6_shift,ma_6_method,ma_6_price);
   
   }
   
   Stoch_handle1 = iStochastic(symbol,sto_1_tf,sto_1_k_period,sto_1_d_period,sto_1_s_period,sto_1_method,sto_1_price);
   Stoch_handle2 = iStochastic(symbol,sto_2_tf,sto_2_k_period,sto_2_d_period,sto_2_s_period,sto_2_method,sto_2_price);
   Stoch_handle3 = iStochastic(symbol,sto_3_tf,sto_3_k_period,sto_3_d_period,sto_3_s_period,sto_3_method,sto_3_price);
   Stoch_handle4 = iStochastic(symbol,sto_4_tf,sto_4_k_period,sto_4_d_period,sto_4_s_period,sto_4_method,sto_4_price);
   Stoch_handle5 = iStochastic(symbol,sto_5_tf,sto_5_k_period,sto_5_d_period,sto_5_s_period,sto_5_method,sto_5_price);
   Stoch_handle6 = iStochastic(symbol,sto_6_tf,sto_6_k_period,sto_6_d_period,sto_6_s_period,sto_6_method,sto_6_price);
   
   handle_macd_1 = iMACD(symbol,macd_1_tf,macd_1_period_fast,macd_1_period_slow,macd_1_period_signal,macd_1_price);
   handle_macd_2 = iMACD(symbol,macd_2_tf,macd_2_period_fast,macd_2_period_slow,macd_2_period_signal,macd_2_price);
   handle_macd_3 = iMACD(symbol,macd_3_tf,macd_3_period_fast,macd_3_period_slow,macd_3_period_signal,macd_3_price);
   handle_macd_4 = iMACD(symbol,macd_4_tf,macd_4_period_fast,macd_4_period_slow,macd_4_period_signal,macd_4_price);
   handle_macd_5 = iMACD(symbol,macd_5_tf,macd_5_period_fast,macd_5_period_slow,macd_5_period_signal,macd_5_price);
   handle_macd_6 = iMACD(symbol,macd_6_tf,macd_6_period_fast,macd_6_period_slow,macd_6_period_signal,macd_6_price);
    
  if((!CopyBufferAsSeries(MA_handle1,0,0,2,true,MA1)&&ma_1_use)||
    (!CopyBufferAsSeries(MA_handle2,0,0,2,true,MA2)&&ma_2_use)||
    (!CopyBufferAsSeries(MA_handle3,0,0,2,true,MA3)&&ma_3_use)||
    (!CopyBufferAsSeries(MA_handle4,0,0,2,true,MA4)&&ma_4_use)||
    (!CopyBufferAsSeries(MA_handle5,0,0,2,true,MA5)&&ma_5_use)||
    (!CopyBufferAsSeries(MA_handle6,0,0,2,true,MA6)&&ma_6_use)||
    (!CopyBufferAsSeries(Stoch_handle1,0,0,2,true,StochM1)&&sto_1_use)||
    (!CopyBufferAsSeries(Stoch_handle1,1,0,2,true,StochS1)&&sto_1_use)||
    (!CopyBufferAsSeries(Stoch_handle2,0,0,2,true,StochM2)&&sto_2_use)||
    (!CopyBufferAsSeries(Stoch_handle2,1,0,2,true,StochS2)&&sto_2_use)||
    (!CopyBufferAsSeries(Stoch_handle3,0,0,2,true,StochM3)&&sto_3_use)||
    (!CopyBufferAsSeries(Stoch_handle3,1,0,2,true,StochS3)&&sto_3_use)||
    (!CopyBufferAsSeries(Stoch_handle4,0,0,2,true,StochM4)&&sto_4_use)||
    (!CopyBufferAsSeries(Stoch_handle4,1,0,2,true,StochS4)&&sto_4_use)||
    (!CopyBufferAsSeries(Stoch_handle5,0,0,2,true,StochM5)&&sto_5_use)||
    (!CopyBufferAsSeries(Stoch_handle5,1,0,2,true,StochS5)&&sto_5_use)||
    (!CopyBufferAsSeries(Stoch_handle6,0,0,2,true,StochM6)&&sto_6_use)||
    (!CopyBufferAsSeries(Stoch_handle6,1,0,2,true,StochS6)&&sto_6_use)||
    (!CopyBufferAsSeries(handle_macd_1,0,0,2,true,macd_main_buff_1)&&macd_1_use)||
    (!CopyBufferAsSeries(handle_macd_1,1,0,2,true,macd_signal_buff_1)&&macd_1_use)||
    (!CopyBufferAsSeries(handle_macd_2,0,0,2,true,macd_main_buff_2)&&macd_2_use)||
    (!CopyBufferAsSeries(handle_macd_2,1,0,2,true,macd_signal_buff_2)&&macd_2_use)||
    (!CopyBufferAsSeries(handle_macd_3,0,0,2,true,macd_main_buff_3)&&macd_3_use)||
    (!CopyBufferAsSeries(handle_macd_3,1,0,2,true,macd_signal_buff_3)&&macd_3_use)||
    (!CopyBufferAsSeries(handle_macd_4,0,0,2,true,macd_main_buff_4)&&macd_4_use)||
    (!CopyBufferAsSeries(handle_macd_4,1,0,2,true,macd_signal_buff_4)&&macd_4_use)||
    (!CopyBufferAsSeries(handle_macd_5,0,0,2,true,macd_main_buff_5)&&macd_5_use)||
    (!CopyBufferAsSeries(handle_macd_5,1,0,2,true,macd_signal_buff_5)&&macd_5_use)||
    (!CopyBufferAsSeries(handle_macd_6,0,0,2,true,macd_main_buff_6)&&macd_6_use)||
    (!CopyBufferAsSeries(handle_macd_6,1,0,2,true,macd_signal_buff_6)&&macd_6_use)) return false;
   
   if(ma_crossover&&((!CopyBufferAsSeries(MA_xhandle1,0,0,2,true,MAX1)&&ma_1_use)||
   (!CopyBufferAsSeries(MA_xhandle2,0,0,2,true,MAX2)&&ma_2_use)||
   (!CopyBufferAsSeries(MA_xhandle3,0,0,2,true,MAX3)&&ma_3_use)||
    (!CopyBufferAsSeries(MA_xhandle4,0,0,2,true,MAX4)&&ma_4_use)||
    (!CopyBufferAsSeries(MA_xhandle5,0,0,2,true,MAX5)&&ma_5_use)||
    (!CopyBufferAsSeries(MA_xhandle6,0,0,2,true,MAX6)&&ma_6_use)))return false;
    
    if(type==0){
    
        if(close<MA1[entry_option]&&ma_1_use)return false;   if(close<MA3[entry_option]&&ma_3_use)return false;
        if(close<MA2[entry_option]&&ma_2_use)return false;   if(close<MA4[entry_option]&&ma_4_use)return false;
        if(close<MA5[entry_option]&&ma_5_use)return false;   if(close<MA6[entry_option]&&ma_6_use)return false;
        
        if(StochM1[entry_option]<StochS1[entry_option]&&sto_1_use)return false;  if(StochM3[entry_option]<StochS3[entry_option]&&sto_3_use)return false;
        if(StochM2[entry_option]<StochS2[entry_option]&&sto_2_use)return false;  if(StochM4[entry_option]<StochS4[entry_option]&&sto_4_use)return false;
        if(StochM5[entry_option]<StochS5[entry_option]&&sto_5_use)return false;  if(StochM6[entry_option]<StochS6[entry_option]&&sto_6_use)return false;
        
        if(macd_main_buff_1[entry_option]<macd_signal_buff_1[entry_option]&&macd_1_use)return false;
        if(macd_main_buff_2[entry_option]<macd_signal_buff_2[entry_option]&&macd_2_use)return false;
        if(macd_main_buff_3[entry_option]<macd_signal_buff_3[entry_option]&&macd_3_use)return false;
        if(macd_main_buff_4[entry_option]<macd_signal_buff_4[entry_option]&&macd_4_use)return false;
        if(macd_main_buff_5[entry_option]<macd_signal_buff_5[entry_option]&&macd_5_use)return false;
        if(macd_main_buff_6[entry_option]<macd_signal_buff_6[entry_option]&&macd_6_use)return false;
     }
    if(type==1){
    
        if(close>MA1[entry_option]&&ma_1_use)return false;   if(close>MA3[entry_option]&&ma_3_use)return false;
        if(close>MA2[entry_option]&&ma_2_use)return false;   if(close>MA4[entry_option]&&ma_4_use)return false;
        if(close>MA5[entry_option]&&ma_5_use)return false;   if(close>MA6[entry_option]&&ma_6_use)return false;
        
        if(StochM1[entry_option]>StochS1[entry_option]&&sto_1_use)return false;  if(StochM3[entry_option]>StochS3[entry_option]&&sto_3_use)return false;
        if(StochM2[entry_option]>StochS2[entry_option]&&sto_2_use)return false;  if(StochM4[entry_option]>StochS4[entry_option]&&sto_4_use)return false;
        if(StochM5[entry_option]>StochS5[entry_option]&&sto_5_use)return false;  if(StochM6[entry_option]>StochS6[entry_option]&&sto_6_use)return false;
        
        if(macd_main_buff_1[entry_option]>macd_signal_buff_1[entry_option]&&macd_1_use)return false;
        if(macd_main_buff_2[entry_option]>macd_signal_buff_2[entry_option]&&macd_2_use)return false;
        if(macd_main_buff_3[entry_option]>macd_signal_buff_3[entry_option]&&macd_3_use)return false;
        if(macd_main_buff_4[entry_option]>macd_signal_buff_4[entry_option]&&macd_4_use)return false;
        if(macd_main_buff_5[entry_option]>macd_signal_buff_5[entry_option]&&macd_5_use)return false;
        if(macd_main_buff_6[entry_option]>macd_signal_buff_6[entry_option]&&macd_6_use)return false;
     }
       
     if(ma_crossover){
    
      if(type==0){
      
        if(MA1[entry_option]<MAX1[entry_option]&&ma_1_use)return false;   if(MA2[entry_option]<MAX2[entry_option]&&ma_2_use)return false;
        if(MA3[entry_option]<MAX3[entry_option]&&ma_3_use)return false;   if(MA4[entry_option]<MAX4[entry_option]&&ma_4_use)return false;
        if(MA5[entry_option]<MAX5[entry_option]&&ma_5_use)return false;   if(MA6[entry_option]<MAX6[entry_option]&&ma_6_use)return false;     
      }
      if(type==1){
      
        if(MA1[entry_option]>MAX1[entry_option]&&ma_1_use)return false;   if(MA2[entry_option]>MAX2[entry_option]&&ma_2_use)return false;
        if(MA3[entry_option]>MAX3[entry_option]&&ma_3_use)return false;   if(MA4[entry_option]>MAX4[entry_option]&&ma_4_use)return false; 
        if(MA5[entry_option]>MAX5[entry_option]&&ma_5_use)return false;   if(MA6[entry_option]>MAX6[entry_option]&&ma_6_use)return false;    
      }
    }
    
    if(sto_1_use&&sto_1_inbetween&&!(StochM1[entry_option]<sto_1_ob&&StochM1[entry_option]>sto_1_os&&StochS1[entry_option]<sto_1_ob&&StochS1[entry_option]>sto_1_os))return false;
    if(sto_2_use&&sto_2_inbetween&&!(StochM2[entry_option]<sto_2_ob&&StochM2[entry_option]>sto_2_os&&StochS2[entry_option]<sto_2_ob&&StochS2[entry_option]>sto_2_os))return false;
    if(sto_3_use&&sto_3_inbetween&&!(StochM3[entry_option]<sto_3_ob&&StochM3[entry_option]>sto_3_os&&StochS3[entry_option]<sto_3_ob&&StochS3[entry_option]>sto_3_os))return false;
    if(sto_4_use&&sto_4_inbetween&&!(StochM4[entry_option]<sto_4_ob&&StochM4[entry_option]>sto_4_os&&StochS4[entry_option]<sto_4_ob&&StochS4[entry_option]>sto_4_os))return false;
    if(sto_5_use&&sto_5_inbetween&&!(StochM5[entry_option]<sto_5_ob&&StochM5[entry_option]>sto_5_os&&StochS5[entry_option]<sto_5_ob&&StochS5[entry_option]>sto_5_os))return false;
    if(sto_6_use&&sto_6_inbetween&&!(StochM6[entry_option]<sto_6_ob&&StochM6[entry_option]>sto_6_os&&StochS6[entry_option]<sto_6_ob&&StochS6[entry_option]>sto_6_os))return false;
    
      if(ma_all_to_large){
         
         int ma_period_arr[];
         int size = 0;
         if(ma_1_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_1_period;}
         if(ma_2_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_2_period;}
         if(ma_3_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_3_period;}
         if(ma_4_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_4_period;}
         if(ma_5_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_5_period;}
         if(ma_6_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_6_period;}
         
         int ma_period_max_ind = ArrayMaximum(ma_period_arr,0,0);
         
         //if(prev_calculated==0 && i==3)Print("nkknk,  ",ma_p_arr[ma_max_ind],"  ", ma_max_ind);
         
         double ma_value_arr[];
         size = 0;
         if(ma_1_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA1[entry_option];}
         if(ma_2_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA2[entry_option];}
         if(ma_3_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA3[entry_option];}
         if(ma_4_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA4[entry_option];}
         if(ma_5_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA5[entry_option];}
         if(ma_6_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA6[entry_option];}
   
         int ma_value_min_ind = ArrayMinimum(ma_value_arr,0,0);
         
         int ma_value_max_ind = ArrayMaximum(ma_value_arr,0,0);
         
         if(ma_period_max_ind != ma_value_min_ind && type == 0)return false;
         if(ma_period_max_ind != ma_value_max_ind && type == 1)return false;
      }
      
      //pivot distance check, check=true unless falsified
      
      //bool piv_check = true;
      if(piv_dis_on){
         double check_price = iClose(symbol,PERIOD_CURRENT,entry_option);
         double min_distance_from = piv_dis_pips_from*Price2pip(symbol);
         double min_distance_to = piv_dis_pips_to*Price2pip(symbol);
         
         pivot_handle = iCustom(symbol,PERIOD_CURRENT,"YBM_Signaller_Pivot_Lines",history_bars,pip_adjust_10,"",true,piv_r_clr,piv_p_clr,piv_s_clr,piv_dis_on,
   piv_dis_pips_from,piv_dis_pips_to,piv_show_text,piv_fsize,piv_text_offset,piv_text_clr_r,piv_text_clr_p,piv_text_clr_s,
   piv_rect,piv_rect_clr_r,piv_rect_clr_p,piv_rect_clr_s);
   
        if(!CopyBufferAsSeries(pivot_handle,0,0,3,true,pr3_buff)||
           !CopyBufferAsSeries(pivot_handle,1,0,3,true,pr2_buff)||
           !CopyBufferAsSeries(pivot_handle,2,0,3,true,pr1_buff)||
           !CopyBufferAsSeries(pivot_handle,3,0,3,true,p_buff)||
           !CopyBufferAsSeries(pivot_handle,4,0,3,true,ps1_buff)||
           !CopyBufferAsSeries(pivot_handle,5,0,3,true,ps2_buff)||
           !CopyBufferAsSeries(pivot_handle,6,0,3,true,ps3_buff)) return false;
         
         //calc note: 
         // - price not not be within the TO/FROM range of any pivot level
         // - pips TO/FROM is directional, based on if price is above/below the main pp
         // - TO = approaching the next further pivot level
         // - FROM = passed the previous pivot level
         // - if price is wihtin r3 and s3, price will be inbetween 2 pivot levels
         // - if above pp, pips TO is approaching the higher p level, eg pp to r1
         // - if below pp, pips TO is approacing the lower p level, eg s2 to s3
         // - if above pp, pips FROM is past the lower p level, eg past r2 if inbetween r2-r3
         // - if below pp, pips FROM is past the higher p level, eg past s1, if inbetween s1-s2
         
         if((check_price>pr3_buff[entry_option])                                       && (check_price - pr3_buff[entry_option+1] < min_distance_from))return false;
         if((check_price<pr3_buff[entry_option] && check_price>pr2_buff[entry_option]) && (pr3_buff[entry_option] - check_price < min_distance_to || check_price - pr2_buff[entry_option] < min_distance_from))return false;
         if((check_price<pr2_buff[entry_option] && check_price>pr1_buff[entry_option]) && (pr2_buff[entry_option] - check_price < min_distance_to || check_price - pr1_buff[entry_option] < min_distance_from))return false;
         if((check_price<pr1_buff[entry_option] && check_price>p_buff[entry_option])   && (pr1_buff[entry_option] - check_price < min_distance_to || check_price - p_buff[entry_option] < min_distance_from))return false;

         if((check_price<p_buff[entry_option] && check_price>ps1_buff[entry_option])   && (p_buff[entry_option] - check_price < min_distance_from || check_price - ps1_buff[entry_option] < min_distance_to))return false;
         if((check_price<ps1_buff[entry_option] && check_price>ps2_buff[entry_option]) && (ps1_buff[entry_option] - check_price < min_distance_from || check_price - ps2_buff[entry_option] < min_distance_to))return false;
         if((check_price<ps2_buff[entry_option] && check_price>ps3_buff[entry_option]) && (ps2_buff[entry_option] - check_price < min_distance_from || check_price - ps3_buff[entry_option] < min_distance_to))return false;
         if((check_price<ps3_buff[entry_option])                                       && (ps3_buff[entry_option] - check_price < min_distance_from))return false;
         
      }//end pivot distance check
    
 return true;  
}

bool checkSignalB(string symbol, int type){

     double close = iClose(symbol,PERIOD_CURRENT,entry_option);
     
    MA_handle1b = iMA(symbol,ma_1b_tf,ma_1b_period,ma_1b_shift,ma_1b_method,ma_1b_price);
   MA_handle2b = iMA(symbol,ma_2b_tf,ma_2b_period,ma_2b_shift,ma_2b_method,ma_2b_price);
   MA_handle3b = iMA(symbol,ma_3b_tf,ma_3b_period,ma_3b_shift,ma_3b_method,ma_3b_price);
   MA_handle4b = iMA(symbol,ma_4b_tf,ma_4b_period,ma_4b_shift,ma_4b_method,ma_4b_price);
   MA_handle5b = iMA(symbol,ma_5b_tf,ma_5b_period,ma_5b_shift,ma_5b_method,ma_5b_price);
   MA_handle6b = iMA(symbol,ma_6b_tf,ma_6b_period,ma_6b_shift,ma_6b_method,ma_6b_price);
   
   if(ma_crossover){
   
   MA_xhandle1b = iMA(symbol,ma_1b_tf,ma_1b_xperiod,ma_1b_shift,ma_1b_method,ma_1b_price);
   MA_xhandle2b = iMA(symbol,ma_2b_tf,ma_2b_xperiod,ma_2b_shift,ma_2b_method,ma_2b_price);
   MA_xhandle3b = iMA(symbol,ma_3b_tf,ma_3b_xperiod,ma_3b_shift,ma_3b_method,ma_3b_price);
   MA_xhandle4b = iMA(symbol,ma_4b_tf,ma_4b_xperiod,ma_4b_shift,ma_4b_method,ma_4b_price);
   MA_xhandle5b = iMA(symbol,ma_5b_tf,ma_5b_xperiod,ma_5b_shift,ma_5b_method,ma_5b_price);
   MA_xhandle6b = iMA(symbol,ma_6b_tf,ma_6b_xperiod,ma_6b_shift,ma_6b_method,ma_6b_price);
   
   }
   
   Stoch_handle1b = iStochastic(symbol,sto_1b_tf,sto_1b_k_period,sto_1b_d_period,sto_1b_s_period,sto_1b_method,sto_1b_price);
   Stoch_handle2b = iStochastic(symbol,sto_2b_tf,sto_2b_k_period,sto_2b_d_period,sto_2b_s_period,sto_2b_method,sto_2b_price);
   Stoch_handle3b = iStochastic(symbol,sto_3b_tf,sto_3b_k_period,sto_3b_d_period,sto_3b_s_period,sto_3b_method,sto_3b_price);
   Stoch_handle4b = iStochastic(symbol,sto_4b_tf,sto_4b_k_period,sto_4b_d_period,sto_4b_s_period,sto_4b_method,sto_4b_price);
   Stoch_handle5b = iStochastic(symbol,sto_5b_tf,sto_5b_k_period,sto_5b_d_period,sto_5b_s_period,sto_5b_method,sto_5b_price);
   Stoch_handle6b = iStochastic(symbol,sto_6b_tf,sto_6b_k_period,sto_6b_d_period,sto_6b_s_period,sto_6b_method,sto_6b_price);
   
   handle_macd_1_b = iMACD(symbol,macd_1_tf_b,macd_1_period_fast_b,macd_1_period_slow_b,macd_1_period_signal_b,macd_1_price_b);
   handle_macd_2_b = iMACD(symbol,macd_2_tf_b,macd_2_period_fast_b,macd_2_period_slow_b,macd_2_period_signal_b,macd_2_price_b);
   handle_macd_3_b = iMACD(symbol,macd_3_tf_b,macd_3_period_fast_b,macd_3_period_slow_b,macd_3_period_signal_b,macd_3_price_b);
   handle_macd_4_b = iMACD(symbol,macd_4_tf_b,macd_4_period_fast_b,macd_4_period_slow_b,macd_4_period_signal_b,macd_4_price_b);
   handle_macd_5_b = iMACD(symbol,macd_5_tf_b,macd_5_period_fast_b,macd_5_period_slow_b,macd_5_period_signal_b,macd_5_price_b);
   handle_macd_6_b = iMACD(symbol,macd_6_tf_b,macd_6_period_fast_b,macd_6_period_slow_b,macd_6_period_signal_b,macd_6_price_b);
     
    if((!CopyBufferAsSeries(MA_handle1b,0,0,2,true,MA1b)&&ma_1b_use)||
    (!CopyBufferAsSeries(MA_handle2b,0,0,2,true,MA2b)&&ma_2b_use)||
    (!CopyBufferAsSeries(MA_handle3b,0,0,2,true,MA3b)&&ma_3b_use)||
    (!CopyBufferAsSeries(MA_handle4b,0,0,2,true,MA4b)&&ma_4b_use)||
    (!CopyBufferAsSeries(MA_handle5b,0,0,2,true,MA5b)&&ma_5b_use)||
    (!CopyBufferAsSeries(MA_handle6b,0,0,2,true,MA6b)&&ma_6b_use)||
    (!CopyBufferAsSeries(Stoch_handle1b,0,0,2,true,StochM1b)&&sto_1b_use)||
    (!CopyBufferAsSeries(Stoch_handle1b,1,0,2,true,StochS1b)&&sto_1b_use)||
    (!CopyBufferAsSeries(Stoch_handle2b,0,0,2,true,StochM2b)&&sto_2b_use)||
    (!CopyBufferAsSeries(Stoch_handle2b,1,0,2,true,StochS2b)&&sto_2b_use)||
    (!CopyBufferAsSeries(Stoch_handle3b,0,0,2,true,StochM3b)&&sto_3b_use)||
    (!CopyBufferAsSeries(Stoch_handle3b,1,0,2,true,StochS3b)&&sto_3b_use)||
    (!CopyBufferAsSeries(Stoch_handle4b,0,0,2,true,StochM4b)&&sto_4b_use)||
    (!CopyBufferAsSeries(Stoch_handle4b,1,0,2,true,StochS4b)&&sto_4b_use)||
    (!CopyBufferAsSeries(Stoch_handle5b,0,0,2,true,StochM5b)&&sto_5b_use)||
    (!CopyBufferAsSeries(Stoch_handle5b,1,0,2,true,StochS5b)&&sto_5b_use)||
    (!CopyBufferAsSeries(Stoch_handle6b,0,0,2,true,StochM6b)&&sto_6b_use)||
    (!CopyBufferAsSeries(Stoch_handle6b,1,0,2,true,StochS6b)&&sto_6b_use)||
    (!CopyBufferAsSeries(handle_macd_1_b,0,0,2,true,macd_main_buff_1_b)&&macd_1_use_b)||
    (!CopyBufferAsSeries(handle_macd_1_b,1,0,2,true,macd_signal_buff_1_b)&&macd_1_use_b)||
    (!CopyBufferAsSeries(handle_macd_2_b,0,0,2,true,macd_main_buff_2_b)&&macd_2_use_b)||
    (!CopyBufferAsSeries(handle_macd_2_b,1,0,2,true,macd_signal_buff_2_b)&&macd_2_use_b)||
    (!CopyBufferAsSeries(handle_macd_3_b,0,0,2,true,macd_main_buff_3_b)&&macd_3_use_b)||
    (!CopyBufferAsSeries(handle_macd_3_b,1,0,2,true,macd_signal_buff_3_b)&&macd_3_use_b)||
    (!CopyBufferAsSeries(handle_macd_4_b,0,0,2,true,macd_main_buff_4_b)&&macd_4_use_b)||
    (!CopyBufferAsSeries(handle_macd_4_b,1,0,2,true,macd_signal_buff_4_b)&&macd_4_use_b)||
    (!CopyBufferAsSeries(handle_macd_5_b,0,0,2,true,macd_main_buff_5_b)&&macd_5_use_b)||
    (!CopyBufferAsSeries(handle_macd_5_b,1,0,2,true,macd_signal_buff_5_b)&&macd_5_use_b)||
    (!CopyBufferAsSeries(handle_macd_6_b,0,0,2,true,macd_main_buff_6_b)&&macd_6_use_b)||
    (!CopyBufferAsSeries(handle_macd_6_b,1,0,2,true,macd_signal_buff_6_b)&&macd_6_use_b)) return false;
   
   if(ma_crossover&&((!CopyBufferAsSeries(MA_xhandle1b,0,0,2,true,MAX1b)&&ma_1b_use)||
   (!CopyBufferAsSeries(MA_xhandle2b,0,0,2,true,MAX2b)&&ma_2b_use)||
   (!CopyBufferAsSeries(MA_xhandle3b,0,0,2,true,MAX3b)&&ma_3b_use)||
    (!CopyBufferAsSeries(MA_xhandle4b,0,0,2,true,MAX4b)&&ma_4b_use)||
    (!CopyBufferAsSeries(MA_xhandle5b,0,0,2,true,MAX5b)&&ma_5b_use)||
    (!CopyBufferAsSeries(MA_xhandle6b,0,0,2,true,MAX6b)&&ma_6b_use)))return false;
    
    if(type==0){
    
        if(close<MA1b[entry_option]&&ma_1b_use)return false;   if(close<MA3b[entry_option]&&ma_3b_use)return false;
        if(close<MA2b[entry_option]&&ma_2b_use)return false;   if(close<MA4b[entry_option]&&ma_4b_use)return false;
        if(close<MA5b[entry_option]&&ma_5b_use)return false;   if(close<MA6b[entry_option]&&ma_6b_use)return false;
        
        if(StochM1b[entry_option]<StochS1b[entry_option]&&sto_1b_use)return false;  if(StochM3b[entry_option]<StochS3b[entry_option]&&sto_3b_use)return false;
        if(StochM2b[entry_option]<StochS2b[entry_option]&&sto_2b_use)return false;  if(StochM4b[entry_option]<StochS4b[entry_option]&&sto_4b_use)return false;
        if(StochM5b[entry_option]<StochS5b[entry_option]&&sto_5b_use)return false;  if(StochM6b[entry_option]<StochS6b[entry_option]&&sto_6b_use)return false;
        
        if(macd_main_buff_1_b[entry_option]<macd_signal_buff_1_b[entry_option]&&macd_1_use_b)return false;
        if(macd_main_buff_2_b[entry_option]<macd_signal_buff_2_b[entry_option]&&macd_2_use_b)return false;
        if(macd_main_buff_3_b[entry_option]<macd_signal_buff_3_b[entry_option]&&macd_3_use_b)return false;
        if(macd_main_buff_4_b[entry_option]<macd_signal_buff_4_b[entry_option]&&macd_4_use_b)return false;
        if(macd_main_buff_5_b[entry_option]<macd_signal_buff_5_b[entry_option]&&macd_5_use_b)return false;
        if(macd_main_buff_6_b[entry_option]<macd_signal_buff_6_b[entry_option]&&macd_6_use_b)return false;
     }
    if(type==1){
    
        if(close>MA1b[entry_option]&&ma_1b_use)return false;   if(close>MA3b[entry_option]&&ma_3b_use)return false;
        if(close>MA2b[entry_option]&&ma_2b_use)return false;   if(close>MA4b[entry_option]&&ma_4b_use)return false;
        if(close>MA5b[entry_option]&&ma_5b_use)return false;   if(close>MA6b[entry_option]&&ma_6b_use)return false;
        
        if(StochM1b[entry_option]>StochS1b[entry_option]&&sto_1b_use)return false;  if(StochM3b[entry_option]>StochS3b[entry_option]&&sto_3b_use)return false;
        if(StochM2b[entry_option]>StochS2b[entry_option]&&sto_2b_use)return false;  if(StochM4b[entry_option]>StochS4b[entry_option]&&sto_4b_use)return false;
        if(StochM5b[entry_option]>StochS5b[entry_option]&&sto_5b_use)return false;  if(StochM6b[entry_option]>StochS6b[entry_option]&&sto_6b_use)return false;
        
        if(macd_main_buff_1_b[entry_option]>macd_signal_buff_1_b[entry_option]&&macd_1_use_b)return false;
        if(macd_main_buff_2_b[entry_option]>macd_signal_buff_2_b[entry_option]&&macd_2_use_b)return false;
        if(macd_main_buff_3_b[entry_option]>macd_signal_buff_3_b[entry_option]&&macd_3_use_b)return false;
        if(macd_main_buff_4_b[entry_option]>macd_signal_buff_4_b[entry_option]&&macd_4_use_b)return false;
        if(macd_main_buff_5_b[entry_option]>macd_signal_buff_5_b[entry_option]&&macd_5_use_b)return false;
        if(macd_main_buff_6_b[entry_option]>macd_signal_buff_6_b[entry_option]&&macd_6_use_b)return false;
     }
       
     if(ma_crossover){
    
      if(type==0){
      
        if(MA1b[entry_option]<MAX1b[entry_option]&&ma_1b_use)return false;   if(MA2b[entry_option]<MAX2b[entry_option]&&ma_2b_use)return false;
        if(MA3b[entry_option]<MAX3b[entry_option]&&ma_3b_use)return false;   if(MA4b[entry_option]<MAX4b[entry_option]&&ma_4b_use)return false;
        if(MA5b[entry_option]<MAX5b[entry_option]&&ma_5b_use)return false;   if(MA6b[entry_option]<MAX6b[entry_option]&&ma_6b_use)return false;     
      }
      if(type==1){
      
        if(MA1b[entry_option]>MAX1b[entry_option]&&ma_1b_use)return false;   if(MA2b[entry_option]>MAX2b[entry_option]&&ma_2b_use)return false;
        if(MA3b[entry_option]>MAX3b[entry_option]&&ma_3b_use)return false;   if(MA4b[entry_option]>MAX4b[entry_option]&&ma_4b_use)return false;
        if(MA5b[entry_option]>MAX5b[entry_option]&&ma_5b_use)return false;   if(MA6b[entry_option]>MAX6b[entry_option]&&ma_6b_use)return false;     
      }
    }
    
    if(sto_1b_use&&sto_1b_inbetween&&!(StochM1b[entry_option]<sto_1b_ob&&StochM1b[entry_option]>sto_1b_os&&StochS1b[entry_option]<sto_1b_ob&&StochS1b[entry_option]>sto_1b_os))return false;
    if(sto_2b_use&&sto_2b_inbetween&&!(StochM2b[entry_option]<sto_2b_ob&&StochM2b[entry_option]>sto_2b_os&&StochS2b[entry_option]<sto_2b_ob&&StochS2b[entry_option]>sto_2b_os))return false;
    if(sto_3b_use&&sto_3b_inbetween&&!(StochM3b[entry_option]<sto_3b_ob&&StochM3b[entry_option]>sto_3b_os&&StochS3b[entry_option]<sto_3b_ob&&StochS3b[entry_option]>sto_3b_os))return false;
    if(sto_4b_use&&sto_4b_inbetween&&!(StochM4b[entry_option]<sto_4b_ob&&StochM4b[entry_option]>sto_4b_os&&StochS4b[entry_option]<sto_4b_ob&&StochS4b[entry_option]>sto_4b_os))return false;
    if(sto_5b_use&&sto_5b_inbetween&&!(StochM5b[entry_option]<sto_5b_ob&&StochM5b[entry_option]>sto_5b_os&&StochS5b[entry_option]<sto_5b_ob&&StochS5b[entry_option]>sto_5b_os))return false;
    if(sto_6b_use&&sto_6b_inbetween&&!(StochM6b[entry_option]<sto_6b_ob&&StochM6b[entry_option]>sto_6b_os&&StochS6b[entry_option]<sto_6b_ob&&StochS6b[entry_option]>sto_6b_os))return false;
    
    if(ma_all_to_large){
         
         int ma_period_arr[];
         int size = 0;
         if(ma_1b_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_1b_period;}
         if(ma_2b_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_2b_period;}
         if(ma_3b_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_3b_period;}
         if(ma_4b_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_4b_period;}
         if(ma_4b_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_4b_period;}
         if(ma_5b_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_5b_period;}
         if(ma_6b_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_6b_period;}
         
         int ma_period_max_ind = ArrayMaximum(ma_period_arr,0,0);
         
         //if(prev_calculated==0 && i==3)Print("nkknk,  ",ma_p_arr[ma_max_ind],"  ", ma_max_ind);
         
         double ma_value_arr[];
         size = 0;
         if(ma_1b_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA1b[entry_option];}
         if(ma_2b_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA2b[entry_option];}
         if(ma_3b_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA3b[entry_option];}
         if(ma_4b_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA4b[entry_option];}
         if(ma_5b_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA5b[entry_option];}
         if(ma_6b_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA6b[entry_option];}
   
         int ma_value_min_ind = ArrayMinimum(ma_value_arr,0,0);
         
         int ma_value_max_ind = ArrayMaximum(ma_value_arr,0,0);
         
         if(ma_period_max_ind != ma_value_min_ind && type == 0)return false;
         if(ma_period_max_ind != ma_value_max_ind && type == 1)return false;
      }
      
      //pivot distance check, check=true unless falsified
      
      //bool piv_check = true;
      if(piv_dis_on){
         double check_price = iClose(symbol,PERIOD_CURRENT,entry_option);
         double min_distance_from = piv_dis_pips_from*Price2pip(symbol);
         double min_distance_to = piv_dis_pips_to*Price2pip(symbol);
         
         pivot_handle = iCustom(symbol,PERIOD_CURRENT,"YBM_Signaller_Pivot_Lines",history_bars,pip_adjust_10,"",true,piv_r_clr,piv_p_clr,piv_s_clr,piv_dis_on,
   piv_dis_pips_from,piv_dis_pips_to,piv_show_text,piv_fsize,piv_text_offset,piv_text_clr_r,piv_text_clr_p,piv_text_clr_s,
   piv_rect,piv_rect_clr_r,piv_rect_clr_p,piv_rect_clr_s);
   
        if(!CopyBufferAsSeries(pivot_handle,0,0,3,true,pr3_buff)||
           !CopyBufferAsSeries(pivot_handle,1,0,3,true,pr2_buff)||
           !CopyBufferAsSeries(pivot_handle,2,0,3,true,pr1_buff)||
           !CopyBufferAsSeries(pivot_handle,3,0,3,true,p_buff)||
           !CopyBufferAsSeries(pivot_handle,4,0,3,true,ps1_buff)||
           !CopyBufferAsSeries(pivot_handle,5,0,3,true,ps2_buff)||
           !CopyBufferAsSeries(pivot_handle,6,0,3,true,ps3_buff)) return false;
         
         //calc note: 
         // - price not not be within the TO/FROM range of any pivot level
         // - pips TO/FROM is directional, based on if price is above/below the main pp
         // - TO = approaching the next further pivot level
         // - FROM = passed the previous pivot level
         // - if price is wihtin r3 and s3, price will be inbetween 2 pivot levels
         // - if above pp, pips TO is approaching the higher p level, eg pp to r1
         // - if below pp, pips TO is approacing the lower p level, eg s2 to s3
         // - if above pp, pips FROM is past the lower p level, eg past r2 if inbetween r2-r3
         // - if below pp, pips FROM is past the higher p level, eg past s1, if inbetween s1-s2
         
         if((check_price>pr3_buff[entry_option])                                       && (check_price - pr3_buff[entry_option+1] < min_distance_from))return false;
         if((check_price<pr3_buff[entry_option] && check_price>pr2_buff[entry_option]) && (pr3_buff[entry_option] - check_price < min_distance_to || check_price - pr2_buff[entry_option] < min_distance_from))return false;
         if((check_price<pr2_buff[entry_option] && check_price>pr1_buff[entry_option]) && (pr2_buff[entry_option] - check_price < min_distance_to || check_price - pr1_buff[entry_option] < min_distance_from))return false;
         if((check_price<pr1_buff[entry_option] && check_price>p_buff[entry_option])   && (pr1_buff[entry_option] - check_price < min_distance_to || check_price - p_buff[entry_option] < min_distance_from))return false;

         if((check_price<p_buff[entry_option] && check_price>ps1_buff[entry_option])   && (p_buff[entry_option] - check_price < min_distance_from || check_price - ps1_buff[entry_option] < min_distance_to))return false;
         if((check_price<ps1_buff[entry_option] && check_price>ps2_buff[entry_option]) && (ps1_buff[entry_option] - check_price < min_distance_from || check_price - ps2_buff[entry_option] < min_distance_to))return false;
         if((check_price<ps2_buff[entry_option] && check_price>ps3_buff[entry_option]) && (ps2_buff[entry_option] - check_price < min_distance_from || check_price - ps3_buff[entry_option] < min_distance_to))return false;
         if((check_price<ps3_buff[entry_option])                                       && (ps3_buff[entry_option] - check_price < min_distance_from))return false;
         
      }//end pivot distance check
  return true;
}


bool checkSignalC(string symbol, int type){

     double close = iClose(symbol,PERIOD_CURRENT,0);
     
    MA_handle1c = iMA(symbol,ma_1c_tf,ma_1c_period,ma_1c_shift,ma_1c_method,ma_1c_price);
   MA_handle2c = iMA(symbol,ma_2c_tf,ma_2c_period,ma_2c_shift,ma_2c_method,ma_2c_price);
   MA_handle3c = iMA(symbol,ma_3c_tf,ma_3c_period,ma_3c_shift,ma_3c_method,ma_3c_price);
   MA_handle4c = iMA(symbol,ma_4c_tf,ma_4c_period,ma_4c_shift,ma_4c_method,ma_4c_price);
   MA_handle5c = iMA(symbol,ma_5c_tf,ma_5c_period,ma_5c_shift,ma_5c_method,ma_5c_price);
   MA_handle6c = iMA(symbol,ma_6c_tf,ma_6c_period,ma_6c_shift,ma_6c_method,ma_6c_price);
   
   if(ma_crossover){
   
   MA_xhandle1c = iMA(symbol,ma_1c_tf,ma_1c_xperiod,ma_1c_shift,ma_1c_method,ma_1c_price);
   MA_xhandle2c = iMA(symbol,ma_2c_tf,ma_2c_xperiod,ma_2c_shift,ma_2c_method,ma_2c_price);
   MA_xhandle3c = iMA(symbol,ma_3c_tf,ma_3c_xperiod,ma_3c_shift,ma_3c_method,ma_3c_price);
   MA_xhandle4c = iMA(symbol,ma_4c_tf,ma_4c_xperiod,ma_4c_shift,ma_4c_method,ma_4c_price);
   MA_xhandle5c = iMA(symbol,ma_5c_tf,ma_5c_xperiod,ma_5c_shift,ma_5c_method,ma_5c_price);
   MA_xhandle6c = iMA(symbol,ma_6c_tf,ma_6c_xperiod,ma_6c_shift,ma_6c_method,ma_6c_price);
   
   }
   
   Stoch_handle1c = iStochastic(symbol,sto_1c_tf,sto_1c_k_period,sto_1c_d_period,sto_1c_s_period,sto_1c_method,sto_1c_price);
   Stoch_handle2c = iStochastic(symbol,sto_2c_tf,sto_2c_k_period,sto_2c_d_period,sto_2c_s_period,sto_2c_method,sto_2c_price);
   Stoch_handle3c = iStochastic(symbol,sto_3c_tf,sto_3c_k_period,sto_3c_d_period,sto_3c_s_period,sto_3c_method,sto_3c_price);
   Stoch_handle4c = iStochastic(symbol,sto_4c_tf,sto_4c_k_period,sto_4c_d_period,sto_4c_s_period,sto_4c_method,sto_4c_price);
   Stoch_handle5c = iStochastic(symbol,sto_5c_tf,sto_5c_k_period,sto_5c_d_period,sto_5c_s_period,sto_5c_method,sto_5c_price);
   Stoch_handle6c = iStochastic(symbol,sto_6c_tf,sto_6c_k_period,sto_6c_d_period,sto_6c_s_period,sto_6c_method,sto_6c_price);
   
   handle_macd_1_c = iMACD(symbol,macd_1_tf_c,macd_1_period_fast_c,macd_1_period_slow_c,macd_1_period_signal_c,macd_1_price_c);
   handle_macd_2_c = iMACD(symbol,macd_2_tf_c,macd_2_period_fast_c,macd_2_period_slow_c,macd_2_period_signal_c,macd_2_price_c);
   handle_macd_3_c = iMACD(symbol,macd_3_tf_c,macd_3_period_fast_c,macd_3_period_slow_c,macd_3_period_signal_c,macd_3_price_c);
   handle_macd_4_c = iMACD(symbol,macd_4_tf_c,macd_4_period_fast_c,macd_4_period_slow_c,macd_4_period_signal_c,macd_4_price_c);
   handle_macd_5_c = iMACD(symbol,macd_5_tf_c,macd_5_period_fast_c,macd_5_period_slow_c,macd_5_period_signal_c,macd_5_price_c);
   handle_macd_6_c = iMACD(symbol,macd_6_tf_c,macd_6_period_fast_c,macd_6_period_slow_c,macd_6_period_signal_c,macd_6_price_c); 
     
    if((!CopyBufferAsSeries(MA_handle1c,0,0,2,true,MA1c)&&ma_1c_use)||
    (!CopyBufferAsSeries(MA_handle2c,0,0,2,true,MA2c)&&ma_2c_use)||
    (!CopyBufferAsSeries(MA_handle3c,0,0,2,true,MA3c)&&ma_3c_use)||
    (!CopyBufferAsSeries(MA_handle4c,0,0,2,true,MA4c)&&ma_4c_use)||
    (!CopyBufferAsSeries(MA_handle5c,0,0,2,true,MA5c)&&ma_5c_use)||
    (!CopyBufferAsSeries(MA_handle6c,0,0,2,true,MA6c)&&ma_6c_use)||
    (!CopyBufferAsSeries(Stoch_handle1c,0,0,2,true,StochM1c)&&sto_1c_use)||
    (!CopyBufferAsSeries(Stoch_handle1c,1,0,2,true,StochS1c)&&sto_1c_use)||
    (!CopyBufferAsSeries(Stoch_handle2c,0,0,2,true,StochM2c)&&sto_2c_use)||
    (!CopyBufferAsSeries(Stoch_handle2c,1,0,2,true,StochS2c)&&sto_2c_use)||
    (!CopyBufferAsSeries(Stoch_handle3c,0,0,2,true,StochM3c)&&sto_3c_use)||
    (!CopyBufferAsSeries(Stoch_handle3c,1,0,2,true,StochS3c)&&sto_3c_use)||
    (!CopyBufferAsSeries(Stoch_handle4c,0,0,2,true,StochM4c)&&sto_4c_use)||
    (!CopyBufferAsSeries(Stoch_handle4c,1,0,2,true,StochS4c)&&sto_4c_use)||
    (!CopyBufferAsSeries(Stoch_handle5c,0,0,2,true,StochM5c)&&sto_5c_use)||
    (!CopyBufferAsSeries(Stoch_handle5c,1,0,2,true,StochS5c)&&sto_5c_use)||
    (!CopyBufferAsSeries(Stoch_handle6c,0,0,2,true,StochM6c)&&sto_6c_use)||
    (!CopyBufferAsSeries(Stoch_handle6c,1,0,2,true,StochS6c)&&sto_6c_use)||
    (!CopyBufferAsSeries(handle_macd_1_c,0,0,2,true,macd_main_buff_1_c)&&macd_1_use_c)||
    (!CopyBufferAsSeries(handle_macd_1_c,1,0,2,true,macd_signal_buff_1_c)&&macd_1_use_c)||
    (!CopyBufferAsSeries(handle_macd_2_c,0,0,2,true,macd_main_buff_2_c)&&macd_2_use_c)||
    (!CopyBufferAsSeries(handle_macd_2_c,1,0,2,true,macd_signal_buff_2_c)&&macd_2_use_c)||
    (!CopyBufferAsSeries(handle_macd_3_c,0,0,2,true,macd_main_buff_3_c)&&macd_3_use_c)||
    (!CopyBufferAsSeries(handle_macd_3_c,1,0,2,true,macd_signal_buff_3_c)&&macd_3_use_c)||
    (!CopyBufferAsSeries(handle_macd_4_c,0,0,2,true,macd_main_buff_4_c)&&macd_4_use_c)||
    (!CopyBufferAsSeries(handle_macd_4_c,1,0,2,true,macd_signal_buff_4_c)&&macd_4_use_c)||
    (!CopyBufferAsSeries(handle_macd_5_c,0,0,2,true,macd_main_buff_5_c)&&macd_5_use_c)||
    (!CopyBufferAsSeries(handle_macd_5_c,1,0,2,true,macd_signal_buff_5_c)&&macd_5_use_c)||
    (!CopyBufferAsSeries(handle_macd_6_c,0,0,2,true,macd_main_buff_6_c)&&macd_6_use_c)||
    (!CopyBufferAsSeries(handle_macd_6_c,1,0,2,true,macd_signal_buff_6_c)&&macd_6_use_c)) return false;
   
   if(ma_crossover&&((!CopyBufferAsSeries(MA_xhandle1c,0,0,2,true,MAX1c)&&ma_1c_use)||
   (!CopyBufferAsSeries(MA_xhandle2c,0,0,2,true,MAX2c)&&ma_2c_use)||
   (!CopyBufferAsSeries(MA_xhandle3c,0,0,2,true,MAX3c)&&ma_3c_use)||
    (!CopyBufferAsSeries(MA_xhandle4c,0,0,2,true,MAX4c)&&ma_4c_use)||
    (!CopyBufferAsSeries(MA_xhandle5c,0,0,2,true,MAX5c)&&ma_5c_use)||
    (!CopyBufferAsSeries(MA_xhandle6c,0,0,2,true,MAX6c)&&ma_6c_use)))return false;
    
    if(type==0){
    
        if(close<MA1c[entry_option]&&ma_1c_use)return false;   if(close<MA3c[entry_option]&&ma_3c_use)return false;
        if(close<MA2c[entry_option]&&ma_2c_use)return false;   if(close<MA4c[entry_option]&&ma_4c_use)return false;
        if(close<MA5c[entry_option]&&ma_5c_use)return false;   if(close<MA6c[entry_option]&&ma_6c_use)return false;
        
        if(StochM1c[entry_option]<StochS1c[entry_option]&&sto_1c_use)return false;  if(StochM3c[entry_option]<StochS3c[entry_option]&&sto_3c_use)return false;
        if(StochM2c[entry_option]<StochS2c[entry_option]&&sto_2c_use)return false;  if(StochM4c[entry_option]<StochS4c[entry_option]&&sto_4c_use)return false;
        if(StochM5c[entry_option]<StochS5c[entry_option]&&sto_5c_use)return false;  if(StochM6c[entry_option]<StochS6c[entry_option]&&sto_6c_use)return false;
        
        if(macd_main_buff_1_c[entry_option]<macd_signal_buff_1_c[entry_option]&&macd_1_use_c)return false;
        if(macd_main_buff_2_c[entry_option]<macd_signal_buff_2_c[entry_option]&&macd_2_use_c)return false;
        if(macd_main_buff_3_c[entry_option]<macd_signal_buff_3_c[entry_option]&&macd_3_use_c)return false;
        if(macd_main_buff_4_c[entry_option]<macd_signal_buff_4_c[entry_option]&&macd_4_use_c)return false;
        if(macd_main_buff_5_c[entry_option]<macd_signal_buff_5_c[entry_option]&&macd_5_use_c)return false;
        if(macd_main_buff_6_c[entry_option]<macd_signal_buff_6_c[entry_option]&&macd_6_use_c)return false;
     }
    if(type==1){
    
        if(close>MA1c[entry_option]&&ma_1c_use)return false;   if(close>MA3c[entry_option]&&ma_3c_use)return false;
        if(close>MA2c[entry_option]&&ma_2c_use)return false;   if(close>MA4c[entry_option]&&ma_4c_use)return false;
        if(close>MA5c[entry_option]&&ma_5c_use)return false;   if(close>MA6c[entry_option]&&ma_6c_use)return false;
        
        if(StochM1c[entry_option]>StochS1c[entry_option]&&sto_1c_use)return false;  if(StochM3c[entry_option]>StochS3c[entry_option]&&sto_3c_use)return false;
        if(StochM2c[entry_option]>StochS2c[entry_option]&&sto_2c_use)return false;  if(StochM4c[entry_option]>StochS4c[entry_option]&&sto_4c_use)return false;
        if(StochM5c[entry_option]>StochS5c[entry_option]&&sto_5c_use)return false;  if(StochM6c[entry_option]>StochS6c[entry_option]&&sto_6c_use)return false;
        
        if(macd_main_buff_1_c[entry_option]>macd_signal_buff_1_c[entry_option]&&macd_1_use_c)return false;
        if(macd_main_buff_2_c[entry_option]>macd_signal_buff_2_c[entry_option]&&macd_2_use_c)return false;
        if(macd_main_buff_3_c[entry_option]>macd_signal_buff_3_c[entry_option]&&macd_3_use_c)return false;
        if(macd_main_buff_4_c[entry_option]>macd_signal_buff_4_c[entry_option]&&macd_4_use_c)return false;
        if(macd_main_buff_5_c[entry_option]>macd_signal_buff_5_c[entry_option]&&macd_5_use_c)return false;
        if(macd_main_buff_6_c[entry_option]>macd_signal_buff_6_c[entry_option]&&macd_6_use_c)return false;
     }
       
     if(ma_crossover){
    
      if(type==0){
      
        if(MA1c[entry_option]<MAX1c[entry_option]&&ma_1c_use)return false;   if(MA2c[entry_option]<MAX2c[entry_option]&&ma_2c_use)return false;
        if(MA3c[entry_option]<MAX3c[entry_option]&&ma_3c_use)return false;   if(MA4c[entry_option]<MAX4c[entry_option]&&ma_4c_use)return false;
        if(MA5c[entry_option]<MAX5c[entry_option]&&ma_5c_use)return false;   if(MA6c[entry_option]<MAX6c[entry_option]&&ma_6c_use)return false;       
      }
      if(type==1){
      
        if(MA1c[entry_option]>MAX1c[entry_option]&&ma_1c_use)return false;   if(MA2c[entry_option]>MAX2c[entry_option]&&ma_2c_use)return false;
        if(MA3c[entry_option]>MAX3c[entry_option]&&ma_3c_use)return false;   if(MA4c[entry_option]>MAX4c[entry_option]&&ma_4c_use)return false;
        if(MA5c[entry_option]>MAX5c[entry_option]&&ma_5c_use)return false;   if(MA6c[entry_option]>MAX6c[entry_option]&&ma_6c_use)return false;       
      }
    }
    
    if(sto_1c_use&&sto_1c_inbetween&&!(StochM1c[entry_option]<sto_1c_ob&&StochM1c[entry_option]>sto_1c_os&&StochS1c[entry_option]<sto_1c_ob&&StochS1c[entry_option]>sto_1c_os))return false;
    if(sto_2c_use&&sto_2c_inbetween&&!(StochM2c[entry_option]<sto_2c_ob&&StochM2c[entry_option]>sto_2c_os&&StochS2c[entry_option]<sto_2c_ob&&StochS2c[entry_option]>sto_2c_os))return false;
    if(sto_3c_use&&sto_3c_inbetween&&!(StochM3c[entry_option]<sto_3c_ob&&StochM3c[entry_option]>sto_3c_os&&StochS3c[entry_option]<sto_3c_ob&&StochS3c[entry_option]>sto_3c_os))return false;
    if(sto_4c_use&&sto_4c_inbetween&&!(StochM4c[entry_option]<sto_4c_ob&&StochM4c[entry_option]>sto_4c_os&&StochS4c[entry_option]<sto_4c_ob&&StochS4c[entry_option]>sto_4c_os))return false;
    if(sto_5c_use&&sto_5c_inbetween&&!(StochM5c[entry_option]<sto_5c_ob&&StochM5c[entry_option]>sto_5c_os&&StochS5c[entry_option]<sto_5c_ob&&StochS5c[entry_option]>sto_5c_os))return false;
    if(sto_6c_use&&sto_6c_inbetween&&!(StochM6c[entry_option]<sto_6c_ob&&StochM6c[entry_option]>sto_6c_os&&StochS6c[entry_option]<sto_6c_ob&&StochS6c[entry_option]>sto_6c_os))return false;
    
    if(ma_all_to_large){
         
         int ma_period_arr[];
         int size = 0;
         if(ma_1c_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_1c_period;}
         if(ma_2c_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_2c_period;}
         if(ma_3c_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_3c_period;}
         if(ma_4c_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_4c_period;}
         if(ma_5c_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_5c_period;}
         if(ma_6c_use){size++;ArrayResize(ma_period_arr,size);ma_period_arr[size-1] = ma_6c_period;}
         
         int ma_period_max_ind = ArrayMaximum(ma_period_arr,0,0);
         
         //if(prev_calculated==0 && i==3)Print("nkknk,  ",ma_p_arr[ma_max_ind],"  ", ma_max_ind);
         
         double ma_value_arr[];
         size = 0;
         if(ma_1c_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA1c[entry_option];}
         if(ma_2c_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA2c[entry_option];}
         if(ma_3c_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA3c[entry_option];}
         if(ma_4c_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA4c[entry_option];}
         if(ma_5c_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA5c[entry_option];}
         if(ma_6c_use){size++;ArrayResize(ma_value_arr,size);ma_value_arr[size-1] = MA6c[entry_option];}
   
         int ma_value_min_ind = ArrayMinimum(ma_value_arr,0,0);
         
         int ma_value_max_ind = ArrayMaximum(ma_value_arr,0,0);
         
         if(ma_period_max_ind != ma_value_min_ind && type == 0)return false;
         if(ma_period_max_ind != ma_value_max_ind && type == 1)return false;
      }
      
       
       //pivot distance check, check=true unless falsified
      
      //bool piv_check = true;
      if(piv_dis_on){
         double check_price = iClose(symbol,PERIOD_CURRENT,entry_option);
         double min_distance_from = piv_dis_pips_from*Price2pip(symbol);
         double min_distance_to = piv_dis_pips_to*Price2pip(symbol);
         
         pivot_handle = iCustom(symbol,PERIOD_CURRENT,"YBM_Signaller_Pivot_Lines",history_bars,pip_adjust_10,"",true,piv_r_clr,piv_p_clr,piv_s_clr,piv_dis_on,
   piv_dis_pips_from,piv_dis_pips_to,piv_show_text,piv_fsize,piv_text_offset,piv_text_clr_r,piv_text_clr_p,piv_text_clr_s,
   piv_rect,piv_rect_clr_r,piv_rect_clr_p,piv_rect_clr_s);
   
        if(!CopyBufferAsSeries(pivot_handle,0,0,3,true,pr3_buff)||
           !CopyBufferAsSeries(pivot_handle,1,0,3,true,pr2_buff)||
           !CopyBufferAsSeries(pivot_handle,2,0,3,true,pr1_buff)||
           !CopyBufferAsSeries(pivot_handle,3,0,3,true,p_buff)||
           !CopyBufferAsSeries(pivot_handle,4,0,3,true,ps1_buff)||
           !CopyBufferAsSeries(pivot_handle,5,0,3,true,ps2_buff)||
           !CopyBufferAsSeries(pivot_handle,6,0,3,true,ps3_buff)) return false;
         
         //calc note: 
         // - price not not be within the TO/FROM range of any pivot level
         // - pips TO/FROM is directional, based on if price is above/below the main pp
         // - TO = approaching the next further pivot level
         // - FROM = passed the previous pivot level
         // - if price is wihtin r3 and s3, price will be inbetween 2 pivot levels
         // - if above pp, pips TO is approaching the higher p level, eg pp to r1
         // - if below pp, pips TO is approacing the lower p level, eg s2 to s3
         // - if above pp, pips FROM is past the lower p level, eg past r2 if inbetween r2-r3
         // - if below pp, pips FROM is past the higher p level, eg past s1, if inbetween s1-s2
         
         if((check_price>pr3_buff[entry_option])                                       && (check_price - pr3_buff[entry_option+1] < min_distance_from))return false;
         if((check_price<pr3_buff[entry_option] && check_price>pr2_buff[entry_option]) && (pr3_buff[entry_option] - check_price < min_distance_to || check_price - pr2_buff[entry_option] < min_distance_from))return false;
         if((check_price<pr2_buff[entry_option] && check_price>pr1_buff[entry_option]) && (pr2_buff[entry_option] - check_price < min_distance_to || check_price - pr1_buff[entry_option] < min_distance_from))return false;
         if((check_price<pr1_buff[entry_option] && check_price>p_buff[entry_option])   && (pr1_buff[entry_option] - check_price < min_distance_to || check_price - p_buff[entry_option] < min_distance_from))return false;

         if((check_price<p_buff[entry_option] && check_price>ps1_buff[entry_option])   && (p_buff[entry_option] - check_price < min_distance_from || check_price - ps1_buff[entry_option] < min_distance_to))return false;
         if((check_price<ps1_buff[entry_option] && check_price>ps2_buff[entry_option]) && (ps1_buff[entry_option] - check_price < min_distance_from || check_price - ps2_buff[entry_option] < min_distance_to))return false;
         if((check_price<ps2_buff[entry_option] && check_price>ps3_buff[entry_option]) && (ps2_buff[entry_option] - check_price < min_distance_from || check_price - ps3_buff[entry_option] < min_distance_to))return false;
         if((check_price<ps3_buff[entry_option])                                       && (ps3_buff[entry_option] - check_price < min_distance_from))return false;
         
      }//end pivot distance check
      
      
  return true;
}


int totalOrders(){

  int total = 0;
    for(int x = PositionsTotal()-1; x>=0; x--){
    
      if(PositionSelectByTicket(PositionGetTicket(x)))
        if(PositionGetInteger(POSITION_MAGIC)==MagicNumber)
          total++;
    }
   return total;
}

int dayOrders(){

  int total = 0;
    HistorySelect(0,TimeCurrent());
      for(int x = HistoryOrdersTotal()-1; x>=0; x--){
      
        if(HistoryOrderSelect(HistoryOrderGetTicket(x)))
          if(OrderGetInteger(ORDER_MAGIC)==MagicNumber){
          
            MqlDateTime dt,dt1;
            TimeToStruct(OrderGetInteger(ORDER_TIME_DONE),dt);
            TimeToStruct(TimeCurrent(),dt1);
            if(dt.day==dt1.day)total++;   
          }
      }
    return total;
}

void trailing(){

  for(int x = PositionsTotal()-1; x>=0; x--){
  
    if(PositionSelectByTicket(PositionGetTicket(x)))
        if(PositionGetInteger(POSITION_MAGIC)==MagicNumber){
        
        double bid = SymbolInfoDouble(PositionGetSymbol(x),SYMBOL_BID);  
        double ask = SymbolInfoDouble(PositionGetSymbol(x),SYMBOL_ASK);
        double tickSize = SymbolInfoDouble(PositionGetSymbol(x),SYMBOL_TRADE_TICK_SIZE);
        if(tickSize == 0.00001 || tickSize == 0.001)
          pips = tickSize*10;
        else
          pips = tickSize;
               
          if(PositionGetInteger(POSITION_TYPE)==0)
            if(bid-PositionGetDouble(POSITION_SL)>2*trail_stop*pips)
              trade.PositionModify(PositionGetTicket(x),bid-trail_stop*pips,PositionGetDouble(POSITION_TP));
            
          if(PositionGetInteger(POSITION_TYPE)==1)
            if(PositionGetDouble(POSITION_SL)-ask>2*trail_stop*pips)
              trade.PositionModify(PositionGetTicket(x),ask+trail_stop*pips,PositionGetDouble(POSITION_TP));
        }
  }
}

void placeOrder(string symbol, int type, int pos){

  double tickSize = SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE);
   if(tickSize == 0.00001 || tickSize == 0.001)
      pips = tickSize*10;
   else
      pips = tickSize;
  double price = SymbolInfoDouble(symbol,SYMBOL_ASK);
  double Ask = SymbolInfoDouble(symbol,SYMBOL_ASK);
  double Bid = SymbolInfoDouble(symbol,SYMBOL_BID);
  double sl = Ask-stoploss*pips;
  double tp = Ask+takeprofit*pips;
  if(type==1){
    price = SymbolInfoDouble(symbol,SYMBOL_BID);
    sl = Bid+stoploss*pips;
    tp = Bid-takeprofit*pips;
  }
    
   if(type==0){
     if(trade.Buy(lotsize,symbol,price,sl,tp)){
     if(alert_pop)Alert("Buy Trade Entered @ ",symbol);
     if(alert_push)SendNotification("Buy Trade Entered @ "+symbol);
     sum_trades++;
     lastTime = TimeCurrent();
    }                    
   }
     else {
     if(trade.Sell(lotsize,symbol,price,sl,tp)){
     if(alert_pop)Alert("Sell Trade Entered @ ",symbol);
     if(alert_push)SendNotification("Sell Trade Entered @ "+symbol);
     lastTime = TimeCurrent();
     sum_trades++;
    } 
   }
   
}
/*
bool checkLines(string symbol, int type){

  double tickSize = SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE);
   if(tickSize == 0.00001 || tickSize == 0.001)
      pips = tickSize*10;
   else
      pips = tickSize;

  double lines[7];
  lines[0] = pivot_prices[ArraySize(pivot_prices)-1];
  lines[1] = res1_prices[ArraySize(res1_prices)-1];
  lines[2] = res2_prices[ArraySize(res2_prices)-1];
  lines[3] = res3_prices[ArraySize(res3_prices)-1];
  lines[4] = sup1_prices[ArraySize(sup1_prices)-1];
  lines[5] = sup2_prices[ArraySize(sup2_prices)-1];
  lines[6] = sup3_prices[ArraySize(sup3_prices)-1];
   
  double price = SymbolInfoDouble(symbol,SYMBOL_ASK);     
    if(type==1)price = SymbolInfoDouble(symbol,SYMBOL_BID);
  double high_point = 0,low_point = 0,high_margin = 0,low_margin = 0;
  
  for(int x = 0; x<7; x++){
  
    if(lines[x]>price&&(lines[x]-price<high_margin||high_margin==0)){
    
      high_point = lines[x];   high_margin = high_point-price;
    }
    
    if(lines[x]<price&&(price-lines[x]<low_margin||low_margin==0)){
    
      low_point = lines[x];   low_margin = price-low_point;
    }
  }
  
    if(high_point>0&&low_point>0){
    
      if(type==0&&high_point-price>=pips_away*pips&&price-low_point>=pips_past*pips)return true;
      if(type==1&&high_point-price>=pips_past*pips&&price-low_point>=pips_away*pips)return true;
    }
  return false;
}*/

bool checkLastSignal(){

  if(lastTime>0&&TimeCurrent()-lastTime<=minutes*60)return false;

   for(int x = OrdersTotal()-1; x>=0; x--){
  
    if(OrderSelect(OrderGetTicket(x)))
        if(OrderGetInteger(ORDER_MAGIC)==MagicNumber){
        
          if(TimeCurrent()-OrderGetInteger(ORDER_TIME_DONE)<=minutes*60)return false;
      }
    }
  return true;
}

bool isNewCandle()
  {

   bool result;
   if(total_bars == Bars(Symbol(),PERIOD_CURRENT))
      result = false;
   else
      result = true;
   total_bars = Bars(Symbol(),PERIOD_CURRENT);
   return result;
  } 
  
  
bool isNewCandle2()
  {

   bool result;  static int total_bars2 = Bars(Symbol(),PERIOD_CURRENT);
   if(total_bars2 == Bars(Symbol(),PERIOD_CURRENT))
      result = false;
   else
      result = true;
   total_bars2 = Bars(Symbol(),PERIOD_CURRENT);
   return result;
  } 
  
  
 void cond_list_make()
{
      string pip_adjust_10_str = "1 Pip = "+DoubleToString(price2pip,_Digits);
      //string all_valid_str = "All valid arrows = OFF";        
        //    if(all_valid)all_valid_str = "All valid arrows = ON";
      string use_live_str = "Use live candle = OFF";          
            if(entry_option==0)use_live_str = "Use live candle = ON";
      string ma_default = "MAs above/below price = ON (default)";     
      //string ma_all_line_up_str = "MAs must line up = OFF";     
         //   if(ma_all_line_up)ma_all_line_up_str = "MAs must line up = ON";
      string ma_crossover_str = "MAs using crossover = OFF";  
            if(ma_crossover)ma_crossover_str = "MAs using crossover = ON";
      string ma_largest_str = "MAs above/below largest = OFF";  
            if(ma_all_to_large)ma_largest_str = "MAs above/below largest = ON";
             
      string seqa_tf_str = "Sequence A = ON (default)";                       
      string ma_1_str = "MA 1a = OFF";                         
            if(ma_1_use)ma_1_str = "MA 1a = ON, "+tf_string(ma_1_tf)+", "+ma_method_string(ma_1_method)+IntegerToString(ma_1_period);
            if(ma_1_use && ma_crossover)ma_1_str = "MA 1a = ON, "+tf_string(ma_1_tf)+", "+ma_method_string(ma_1_method)+IntegerToString(ma_1_period)+", cross period="+IntegerToString(ma_1_xperiod);
      string ma_2_str = "MA 2a = OFF";                         
            if(ma_2_use)ma_2_str = "MA 2a = ON, "+tf_string(ma_2_tf)+", "+ma_method_string(ma_2_method)+IntegerToString(ma_2_period);
            if(ma_2_use && ma_crossover)ma_2_str = "MA 2a = ON, "+tf_string(ma_2_tf)+", "+ma_method_string(ma_2_method)+IntegerToString(ma_2_period)+", cross period="+IntegerToString(ma_2_xperiod);
      string ma_3_str = "MA 3a = OFF";                         
            if(ma_3_use)ma_3_str = "MA 3a = ON, "+tf_string(ma_3_tf)+", "+ma_method_string(ma_3_method)+IntegerToString(ma_3_period);
            if(ma_3_use && ma_crossover)ma_3_str = "MA 3a = ON, "+tf_string(ma_3_tf)+", "+ma_method_string(ma_3_method)+IntegerToString(ma_3_period)+", cross period="+IntegerToString(ma_3_xperiod);
      string ma_4_str = "MA 4a = OFF";                         
            if(ma_4_use)ma_4_str = "MA 4a = ON, "+tf_string(ma_4_tf)+", "+ma_method_string(ma_4_method)+IntegerToString(ma_4_period);
            if(ma_4_use && ma_crossover)ma_4_str = "MA 4a = ON, "+tf_string(ma_4_tf)+", "+ma_method_string(ma_4_method)+IntegerToString(ma_4_period)+", cross period="+IntegerToString(ma_4_xperiod);
      string ma_5_str = "MA 5a = OFF";                         
            if(ma_5_use)ma_5_str = "MA 5a = ON, "+tf_string(ma_5_tf)+", "+ma_method_string(ma_5_method)+IntegerToString(ma_5_period);
            if(ma_5_use && ma_crossover)ma_5_str = "MA 5a = ON, "+tf_string(ma_5_tf)+", "+ma_method_string(ma_5_method)+IntegerToString(ma_5_period)+", cross period="+IntegerToString(ma_5_xperiod);
      
      string ma_6_str = "MA 6a = OFF";                         
            if(ma_6_use)ma_6_str = "MA 6a = ON, "+tf_string(ma_6_tf)+", "+ma_method_string(ma_6_method)+IntegerToString(ma_6_period);
            if(ma_6_use && ma_crossover)ma_6_str = "MA 6a = ON, "+tf_string(ma_6_tf)+", "+ma_method_string(ma_6_method)+IntegerToString(ma_6_period)+", cross period="+IntegerToString(ma_6_xperiod);
      
      string sto_default = "Sto main/sig must align = ON (default)";                       
      string sto_1_str = "Sto 1a = OFF";                       
            if(sto_1_use)sto_1_str = "Sto 1a = ON, "+tf_string(sto_1_tf)+", k="+IntegerToString(sto_1_k_period)+", d="+IntegerToString(sto_1_d_period)+", s="+IntegerToString(sto_1_s_period);
            if(sto_1_use && sto_1_inbetween)sto_1_str = "Sto 1a = ON, "+tf_string(sto_1_tf)+", k="+IntegerToString(sto_1_k_period)+", d="+IntegerToString(sto_1_d_period)+", s="+IntegerToString(sto_1_s_period)+", within OB="+IntegerToString(sto_1_ob)+", OS="+IntegerToString(sto_1_os);
      string sto_2_str = "Sto 2a = OFF";                       
            if(sto_2_use)sto_2_str = "Sto 2a = ON, "+tf_string(sto_2_tf)+", k="+IntegerToString(sto_2_k_period)+", d="+IntegerToString(sto_2_d_period)+", s="+IntegerToString(sto_2_s_period);
            if(sto_2_use && sto_2_inbetween)sto_2_str = "Sto 2a = ON, "+tf_string(sto_2_tf)+", k="+IntegerToString(sto_2_k_period)+", d="+IntegerToString(sto_2_d_period)+", s="+IntegerToString(sto_2_s_period)+", within OB="+IntegerToString(sto_2_ob)+", OS="+IntegerToString(sto_2_os);
      string sto_3_str = "Sto 3a = OFF";                       
            if(sto_3_use)sto_3_str = "Sto 3a = ON, "+tf_string(sto_3_tf)+", k="+IntegerToString(sto_3_k_period)+", d="+IntegerToString(sto_3_d_period)+", s="+IntegerToString(sto_3_s_period);
            if(sto_3_use && sto_3_inbetween)sto_3_str = "Sto 3a = ON, "+tf_string(sto_3_tf)+", k="+IntegerToString(sto_3_k_period)+", d="+IntegerToString(sto_3_d_period)+", s="+IntegerToString(sto_3_s_period)+", within OB="+IntegerToString(sto_3_ob)+", OS="+IntegerToString(sto_3_os);
      string sto_4_str = "Sto 4a = OFF";                       
            if(sto_4_use)sto_4_str = "Sto 4a = ON, "+tf_string(sto_4_tf)+", k="+IntegerToString(sto_4_k_period)+", d="+IntegerToString(sto_4_d_period)+", s="+IntegerToString(sto_4_s_period);
            if(sto_4_use && sto_4_inbetween)sto_4_str = "Sto 4a = ON, "+tf_string(sto_4_tf)+", k="+IntegerToString(sto_4_k_period)+", d="+IntegerToString(sto_4_d_period)+", s="+IntegerToString(sto_4_s_period)+", within OB="+IntegerToString(sto_4_ob)+", OS="+IntegerToString(sto_4_os);
      string sto_5_str = "Sto 5a = OFF";                       
            if(sto_5_use)sto_5_str = "Sto 5a = ON, "+tf_string(sto_5_tf)+", k="+IntegerToString(sto_5_k_period)+", d="+IntegerToString(sto_5_d_period)+", s="+IntegerToString(sto_5_s_period);
            if(sto_5_use && sto_5_inbetween)sto_5_str = "Sto 5a = ON, "+tf_string(sto_5_tf)+", k="+IntegerToString(sto_5_k_period)+", d="+IntegerToString(sto_5_d_period)+", s="+IntegerToString(sto_5_s_period)+", within OB="+IntegerToString(sto_5_ob)+", OS="+IntegerToString(sto_5_os);
      
      string sto_6_str = "Sto 6a = OFF";                       
            if(sto_6_use)sto_6_str = "Sto 6a = ON, "+tf_string(sto_6_tf)+", k="+IntegerToString(sto_6_k_period)+", d="+IntegerToString(sto_6_d_period)+", s="+IntegerToString(sto_6_s_period);
            if(sto_6_use && sto_6_inbetween)sto_6_str = "Sto 6a = ON, "+tf_string(sto_6_tf)+", k="+IntegerToString(sto_6_k_period)+", d="+IntegerToString(sto_6_d_period)+", s="+IntegerToString(sto_6_s_period)+", within OB="+IntegerToString(sto_6_ob)+", OS="+IntegerToString(sto_6_os);
      
      string macd_default = "MACD main/signal align = ON (default)";   
                          
      string macd_1_str = "A MACD 1 = OFF";                       
            if(macd_1_use)macd_1_str = "A MACD 1, "+tf_string(macd_1_tf)+", f="+IntegerToString(macd_1_period_fast)+", s="+IntegerToString(macd_1_period_slow)+", sig="+IntegerToString(macd_1_period_signal);
      string macd_2_str = "A MACD 2 = OFF";                       
            if(macd_2_use)macd_2_str = "A MACD 2, "+tf_string(macd_2_tf)+", f="+IntegerToString(macd_2_period_fast)+", s="+IntegerToString(macd_2_period_slow)+", sig="+IntegerToString(macd_2_period_signal);
      string macd_3_str = "A MACD 3 = OFF";                       
            if(macd_3_use)macd_3_str = "A MACD 3, "+tf_string(macd_3_tf)+", f="+IntegerToString(macd_3_period_fast)+", s="+IntegerToString(macd_3_period_slow)+", sig="+IntegerToString(macd_3_period_signal);
      string macd_4_str = "A MACD 4 = OFF";                       
            if(macd_4_use)macd_4_str = "A MACD 4, "+tf_string(macd_4_tf)+", f="+IntegerToString(macd_4_period_fast)+", s="+IntegerToString(macd_4_period_slow)+", sig="+IntegerToString(macd_4_period_signal);
      string macd_5_str = "A MACD 5 = OFF";                       
            if(macd_5_use)macd_5_str = "A MACD 5, "+tf_string(macd_5_tf)+", f="+IntegerToString(macd_5_period_fast)+", s="+IntegerToString(macd_5_period_slow)+", sig="+IntegerToString(macd_5_period_signal);
      string macd_6_str = "A MACD 6 = OFF";                       
            if(macd_6_use)macd_6_str = "A MACD 6, "+tf_string(macd_6_tf)+", f="+IntegerToString(macd_6_period_fast)+", s="+IntegerToString(macd_6_period_slow)+", sig="+IntegerToString(macd_6_period_signal);
      
      
      string seqb_tf_str = "Sequence B = OFF";                       
            if(seqb_use)seqb_tf_str = "Sequence B = ON";    
      string ma_1b_str = "MA 1b = OFF";                         
            if(seqb_use && ma_1b_use)ma_1b_str = "MA 1b = ON, "+tf_string(ma_1b_tf)+", "+ma_method_string(ma_1b_method)+IntegerToString(ma_1b_period);
            if(seqb_use && ma_1b_use && ma_crossover)ma_1_str = "MA 1b = ON, "+tf_string(ma_1b_tf)+", "+ma_method_string(ma_1b_method)+IntegerToString(ma_1b_period)+", cross period="+IntegerToString(ma_1b_xperiod);
      string ma_2b_str = "MA 2b = OFF";                         
            if(seqb_use && ma_2b_use)ma_2b_str = "MA 2b = ON, "+tf_string(ma_2b_tf)+", "+ma_method_string(ma_2b_method)+IntegerToString(ma_2b_period);
            if(seqb_use && ma_2b_use && ma_crossover)ma_2_str = "MA 2b = ON, "+tf_string(ma_2b_tf)+", "+ma_method_string(ma_2b_method)+IntegerToString(ma_2b_period)+", cross period="+IntegerToString(ma_2b_xperiod);
      string ma_3b_str = "MA 3b = OFF";                         
            if(seqb_use && ma_3b_use)ma_3b_str = "MA 3b = ON, "+tf_string(ma_3b_tf)+", "+ma_method_string(ma_3b_method)+IntegerToString(ma_3b_period);
            if(seqb_use && ma_3b_use && ma_crossover)ma_3_str = "MA 3b = ON, "+tf_string(ma_3b_tf)+", "+ma_method_string(ma_3b_method)+IntegerToString(ma_3b_period)+", cross period="+IntegerToString(ma_3b_xperiod);
      string ma_4b_str = "MA 4b = OFF";                         
            if(seqb_use && ma_4b_use)ma_4b_str = "MA 4b = ON, "+tf_string(ma_4b_tf)+", "+ma_method_string(ma_4b_method)+IntegerToString(ma_4b_period);
            if(seqb_use && ma_4b_use && ma_crossover)ma_4_str = "MA 4b = ON, "+tf_string(ma_4b_tf)+", "+ma_method_string(ma_4b_method)+IntegerToString(ma_4b_period)+", cross period="+IntegerToString(ma_4b_xperiod);
      string ma_5b_str = "MA 5b = OFF";                         
            if(seqb_use && ma_5b_use)ma_5b_str = "MA 5b = ON, "+tf_string(ma_5b_tf)+", "+ma_method_string(ma_5b_method)+IntegerToString(ma_5b_period);
            if(seqb_use && ma_5b_use && ma_crossover)ma_5_str = "MA 5b = ON, "+tf_string(ma_5b_tf)+", "+ma_method_string(ma_5b_method)+IntegerToString(ma_5b_period)+", cross period="+IntegerToString(ma_5b_xperiod);
      
      string ma_6b_str = "MA 6b = OFF";                         
            if(seqb_use && ma_6b_use)ma_6b_str = "MA 6b = ON, "+tf_string(ma_6b_tf)+", "+ma_method_string(ma_6b_method)+IntegerToString(ma_6b_period);
            if(seqb_use && ma_6b_use && ma_crossover)ma_6_str = "MA 6b = ON, "+tf_string(ma_6b_tf)+", "+ma_method_string(ma_6b_method)+IntegerToString(ma_6b_period)+", cross period="+IntegerToString(ma_6b_xperiod);
      
      string seqb_sto_default = "Sto main/sig must align = ON (default)";                       
      string sto_1b_str = "Sto 1b = OFF";                       
            if(seqb_use && sto_1b_use)sto_1b_str = "Sto 1b = ON, "+tf_string(sto_1b_tf)+", k="+IntegerToString(sto_1b_k_period)+", d="+IntegerToString(sto_1b_d_period)+", s="+IntegerToString(sto_1b_s_period);
            if(seqb_use && sto_1b_use && sto_1b_inbetween)sto_1b_str = "Sto 1b = ON, "+tf_string(sto_1b_tf)+", k="+IntegerToString(sto_1b_k_period)+", d="+IntegerToString(sto_1b_d_period)+", s="+IntegerToString(sto_1b_s_period)+", within OB="+IntegerToString(sto_1b_ob)+", OS="+IntegerToString(sto_1b_os);
      string sto_2b_str = "Sto 2b = OFF";                       
            if(seqb_use && sto_2b_use)sto_2b_str = "Sto 2b = ON, "+tf_string(sto_2b_tf)+", k="+IntegerToString(sto_2b_k_period)+", d="+IntegerToString(sto_2b_d_period)+", s="+IntegerToString(sto_2b_s_period);
            if(seqb_use && sto_2b_use && sto_2b_inbetween)sto_2b_str = "Sto 2b = ON, "+tf_string(sto_2b_tf)+", k="+IntegerToString(sto_2b_k_period)+", d="+IntegerToString(sto_2b_d_period)+", s="+IntegerToString(sto_2b_s_period)+", within OB="+IntegerToString(sto_2b_ob)+", OS="+IntegerToString(sto_2b_os);
      string sto_3b_str = "Sto 3b = OFF";                       
            if(seqb_use && sto_3b_use)sto_3b_str = "Sto 3b = ON, "+tf_string(sto_3b_tf)+", k="+IntegerToString(sto_3b_k_period)+", d="+IntegerToString(sto_3b_d_period)+", s="+IntegerToString(sto_3b_s_period);
            if(seqb_use && sto_3b_use && sto_3b_inbetween)sto_3b_str = "Sto 3b = ON, "+tf_string(sto_3b_tf)+", k="+IntegerToString(sto_3b_k_period)+", d="+IntegerToString(sto_3b_d_period)+", s="+IntegerToString(sto_3b_s_period)+", within OB="+IntegerToString(sto_3b_ob)+", OS="+IntegerToString(sto_3b_os);
      string sto_4b_str = "Sto 4b = OFF";                       
            if(seqb_use && sto_4b_use)sto_4b_str = "Sto 4b = ON, "+tf_string(sto_4b_tf)+", k="+IntegerToString(sto_4b_k_period)+", d="+IntegerToString(sto_4b_d_period)+", s="+IntegerToString(sto_4b_s_period);
            if(seqb_use && sto_4b_use && sto_4b_inbetween)sto_4b_str = "Sto 4b = ON, "+tf_string(sto_4b_tf)+", k="+IntegerToString(sto_4b_k_period)+", d="+IntegerToString(sto_4b_d_period)+", s="+IntegerToString(sto_4b_s_period)+", within OB="+IntegerToString(sto_4b_ob)+", OS="+IntegerToString(sto_4b_os);
      string sto_5b_str = "Sto 5b = OFF";                       
            if(seqb_use && sto_5b_use)sto_5b_str = "Sto 5b = ON, "+tf_string(sto_5b_tf)+", k="+IntegerToString(sto_5b_k_period)+", d="+IntegerToString(sto_5b_d_period)+", s="+IntegerToString(sto_5b_s_period);
            if(seqb_use && sto_5b_use && sto_5b_inbetween)sto_5b_str = "Sto 5b = ON, "+tf_string(sto_5b_tf)+", k="+IntegerToString(sto_5b_k_period)+", d="+IntegerToString(sto_5b_d_period)+", s="+IntegerToString(sto_5b_s_period)+", within OB="+IntegerToString(sto_5b_ob)+", OS="+IntegerToString(sto_5b_os);
      
      string sto_6b_str = "Sto 6b = OFF";                       
            if(seqb_use && sto_6b_use)sto_6b_str = "Sto 6b = ON, "+tf_string(sto_6b_tf)+", k="+IntegerToString(sto_6b_k_period)+", d="+IntegerToString(sto_6b_d_period)+", s="+IntegerToString(sto_6b_s_period);
            if(seqb_use && sto_6b_use && sto_6b_inbetween)sto_6b_str = "Sto 6b = ON, "+tf_string(sto_6b_tf)+", k="+IntegerToString(sto_6b_k_period)+", d="+IntegerToString(sto_6b_d_period)+", s="+IntegerToString(sto_6b_s_period)+", within OB="+IntegerToString(sto_6b_ob)+", OS="+IntegerToString(sto_6b_os);
      
      string macd_1_str_b = "B MACD 1 = OFF";                       
            if(seqb_use && macd_1_use_b)macd_1_str_b = "B MACD 1, "+tf_string(macd_1_tf_b)+", f="+IntegerToString(macd_1_period_fast_b)+", s="+IntegerToString(macd_1_period_slow_b)+", sig="+IntegerToString(macd_1_period_signal_b);
      string macd_2_str_b = "B MACD 2 = OFF";                       
            if(seqb_use && macd_2_use_b)macd_2_str_b = "B MACD 2, "+tf_string(macd_2_tf_b)+", f="+IntegerToString(macd_2_period_fast_b)+", s="+IntegerToString(macd_2_period_slow_b)+", sig="+IntegerToString(macd_2_period_signal_b);
      string macd_3_str_b = "B MACD 3 = OFF";                       
            if(seqb_use && macd_3_use_b)macd_3_str_b = "B MACD 3, "+tf_string(macd_3_tf_b)+", f="+IntegerToString(macd_3_period_fast_b)+", s="+IntegerToString(macd_3_period_slow_b)+", sig="+IntegerToString(macd_3_period_signal_b);
      string macd_4_str_b = "B MACD 4 = OFF";                       
            if(seqb_use && macd_4_use_b)macd_4_str_b = "B MACD 4, "+tf_string(macd_4_tf_b)+", f="+IntegerToString(macd_4_period_fast_b)+", s="+IntegerToString(macd_4_period_slow_b)+", sig="+IntegerToString(macd_4_period_signal_b);
      string macd_5_str_b = "B MACD 5 = OFF";                       
            if(seqb_use && macd_5_use_b)macd_5_str_b = "B MACD 5, "+tf_string(macd_5_tf_b)+", f="+IntegerToString(macd_5_period_fast_b)+", s="+IntegerToString(macd_5_period_slow_b)+", sig="+IntegerToString(macd_5_period_signal_b);
      string macd_6_str_b = "B MACD 6 = OFF";                       
            if(seqb_use && macd_6_use_b)macd_6_str_b = "B MACD 6, "+tf_string(macd_6_tf_b)+", f="+IntegerToString(macd_6_period_fast_b)+", s="+IntegerToString(macd_6_period_slow_b)+", sig="+IntegerToString(macd_6_period_signal_b);
      
      string seqc_tf_str = "Sequence C = OFF";                       
            if(seqc_use)seqc_tf_str = "Sequence C = ON";    
      string ma_1c_str = "MA 1c = OFF";                         
            if(seqc_use && ma_1c_use)ma_1c_str = "MA 1c = ON, "+tf_string(ma_1c_tf)+", "+ma_method_string(ma_1c_method)+IntegerToString(ma_1c_period);
            if(seqc_use && ma_1c_use && ma_crossover)ma_1_str = "MA 1c = ON, "+tf_string(ma_1c_tf)+", "+ma_method_string(ma_1c_method)+IntegerToString(ma_1c_period)+", cross period="+IntegerToString(ma_1c_xperiod);
      string ma_2c_str = "MA 2c = OFF";                         
            if(seqc_use && ma_2c_use)ma_2c_str = "MA 2c = ON, "+tf_string(ma_2c_tf)+", "+ma_method_string(ma_2c_method)+IntegerToString(ma_2c_period);
            if(seqc_use && ma_2c_use && ma_crossover)ma_2_str = "MA 2c = ON, "+tf_string(ma_2c_tf)+", "+ma_method_string(ma_2c_method)+IntegerToString(ma_2c_period)+", cross period="+IntegerToString(ma_2c_xperiod);
      string ma_3c_str = "MA 3c = OFF";                         
            if(seqc_use && ma_3c_use)ma_3b_str = "MA 3c = ON, "+tf_string(ma_3c_tf)+", "+ma_method_string(ma_3c_method)+IntegerToString(ma_3c_period);
            if(seqc_use && ma_3c_use && ma_crossover)ma_3_str = "MA 3c = ON, "+tf_string(ma_3c_tf)+", "+ma_method_string(ma_3c_method)+IntegerToString(ma_3c_period)+", cross period="+IntegerToString(ma_3c_xperiod);
      string ma_4c_str = "MA 4c = OFF";                         
            if(seqc_use && ma_4c_use)ma_4c_str = "MA 4c = ON, "+tf_string(ma_4c_tf)+", "+ma_method_string(ma_4c_method)+IntegerToString(ma_4c_period);
            if(seqc_use && ma_4c_use && ma_crossover)ma_4_str = "MA 4c = ON, "+tf_string(ma_4c_tf)+", "+ma_method_string(ma_4c_method)+IntegerToString(ma_4c_period)+", cross period="+IntegerToString(ma_4c_xperiod);
      string ma_5c_str = "MA 5c = OFF";                         
            if(seqc_use && ma_5c_use)ma_5c_str = "MA 5c = ON, "+tf_string(ma_5c_tf)+", "+ma_method_string(ma_5c_method)+IntegerToString(ma_5c_period);
            if(seqc_use && ma_5c_use && ma_crossover)ma_5_str = "MA 5c = ON, "+tf_string(ma_5c_tf)+", "+ma_method_string(ma_5c_method)+IntegerToString(ma_5c_period)+", cross period="+IntegerToString(ma_5c_xperiod);
      string ma_6c_str = "MA 6c = OFF";                         
            if(seqc_use && ma_6c_use)ma_6c_str = "MA 6c = ON, "+tf_string(ma_6c_tf)+", "+ma_method_string(ma_6c_method)+IntegerToString(ma_6c_period);
            if(seqc_use && ma_6c_use && ma_crossover)ma_6_str = "MA 6c = ON, "+tf_string(ma_6c_tf)+", "+ma_method_string(ma_6c_method)+IntegerToString(ma_6c_period)+", cross period="+IntegerToString(ma_6c_xperiod);
      
      string seqc_sto_default = "Sto main/sig must align = ON (default)";                       
      string sto_1c_str = "Sto 1c = OFF";                       
            if(seqc_use && sto_1c_use)sto_1c_str = "Sto 1c = ON, "+tf_string(sto_1c_tf)+", k="+IntegerToString(sto_1c_k_period)+", d="+IntegerToString(sto_1c_d_period)+", s="+IntegerToString(sto_1c_s_period);
            if(seqc_use && sto_1c_use && sto_1c_inbetween)sto_1c_str = "Sto 1c = ON, "+tf_string(sto_1c_tf)+", k="+IntegerToString(sto_1c_k_period)+", d="+IntegerToString(sto_1c_d_period)+", s="+IntegerToString(sto_1c_s_period)+", within OB="+IntegerToString(sto_1c_ob)+", OS="+IntegerToString(sto_1c_os);
      string sto_2c_str = "Sto 2c = OFF";                       
            if(seqc_use && sto_2c_use)sto_2c_str = "Sto 2c = ON, "+tf_string(sto_2c_tf)+", k="+IntegerToString(sto_2c_k_period)+", d="+IntegerToString(sto_2c_d_period)+", s="+IntegerToString(sto_2c_s_period);
            if(seqc_use && sto_2c_use && sto_2c_inbetween)sto_2c_str = "Sto 2c = ON, "+tf_string(sto_2c_tf)+", k="+IntegerToString(sto_2c_k_period)+", d="+IntegerToString(sto_2c_d_period)+", s="+IntegerToString(sto_2c_s_period)+", within OB="+IntegerToString(sto_2c_ob)+", OS="+IntegerToString(sto_2c_os);
      string sto_3c_str = "Sto 3c = OFF";                       
            if(seqc_use && sto_3c_use)sto_3c_str = "Sto 3c = ON, "+tf_string(sto_3c_tf)+", k="+IntegerToString(sto_3c_k_period)+", d="+IntegerToString(sto_3c_d_period)+", s="+IntegerToString(sto_3c_s_period);
            if(seqc_use && sto_3c_use && sto_3c_inbetween)sto_3c_str = "Sto 3c = ON, "+tf_string(sto_3c_tf)+", k="+IntegerToString(sto_3c_k_period)+", d="+IntegerToString(sto_3c_d_period)+", s="+IntegerToString(sto_3c_s_period)+", within OB="+IntegerToString(sto_3c_ob)+", OS="+IntegerToString(sto_3c_os);
      string sto_4c_str = "Sto 4c = OFF";                       
            if(seqc_use && sto_4c_use)sto_4c_str = "Sto 4c = ON, "+tf_string(sto_4c_tf)+", k="+IntegerToString(sto_4c_k_period)+", d="+IntegerToString(sto_4c_d_period)+", s="+IntegerToString(sto_4c_s_period);
            if(seqc_use && sto_4c_use && sto_4c_inbetween)sto_4c_str = "Sto 4c = ON, "+tf_string(sto_4c_tf)+", k="+IntegerToString(sto_4c_k_period)+", d="+IntegerToString(sto_4c_d_period)+", s="+IntegerToString(sto_4c_s_period)+", within OB="+IntegerToString(sto_4c_ob)+", OS="+IntegerToString(sto_4c_os);
      string sto_5c_str = "Sto 5c = OFF";                       
            if(seqc_use && sto_5c_use)sto_5c_str = "Sto 5c = ON, "+tf_string(sto_5c_tf)+", k="+IntegerToString(sto_5c_k_period)+", d="+IntegerToString(sto_5c_d_period)+", s="+IntegerToString(sto_5c_s_period);
            if(seqc_use && sto_5c_use && sto_5c_inbetween)sto_5c_str = "Sto 5c = ON, "+tf_string(sto_5c_tf)+", k="+IntegerToString(sto_5c_k_period)+", d="+IntegerToString(sto_5c_d_period)+", s="+IntegerToString(sto_5c_s_period)+", within OB="+IntegerToString(sto_5c_ob)+", OS="+IntegerToString(sto_5c_os);
      string sto_6c_str = "Sto 6c = OFF";                       
            if(seqc_use && sto_6c_use)sto_6c_str = "Sto 6c = ON, "+tf_string(sto_6c_tf)+", k="+IntegerToString(sto_6c_k_period)+", d="+IntegerToString(sto_6c_d_period)+", s="+IntegerToString(sto_6c_s_period);
            if(seqc_use && sto_6c_use && sto_6c_inbetween)sto_6c_str = "Sto 6c = ON, "+tf_string(sto_6c_tf)+", k="+IntegerToString(sto_6c_k_period)+", d="+IntegerToString(sto_6c_d_period)+", s="+IntegerToString(sto_6c_s_period)+", within OB="+IntegerToString(sto_6c_ob)+", OS="+IntegerToString(sto_6c_os);
      
      string macd_1_str_c = "C MACD 1 = OFF";                       
            if(seqc_use && macd_1_use_c)macd_1_str_c = "C MACD 1, "+tf_string(macd_1_tf_c)+", f="+IntegerToString(macd_1_period_fast_c)+", s="+IntegerToString(macd_1_period_slow_c)+", sig="+IntegerToString(macd_1_period_signal_c);
      string macd_2_str_c = "C MACD 2 = OFF";                       
            if(seqc_use && macd_2_use_c)macd_2_str_c = "C MACD 2, "+tf_string(macd_2_tf_c)+", f="+IntegerToString(macd_2_period_fast_c)+", s="+IntegerToString(macd_2_period_slow_c)+", sig="+IntegerToString(macd_2_period_signal_c);
      string macd_3_str_c = "C MACD 3 = OFF";                       
            if(seqc_use && macd_3_use_c)macd_3_str_c = "C MACD 3, "+tf_string(macd_3_tf_c)+", f="+IntegerToString(macd_3_period_fast_c)+", s="+IntegerToString(macd_3_period_slow_c)+", sig="+IntegerToString(macd_3_period_signal_c);
      string macd_4_str_c = "C MACD 4 = OFF";                       
            if(seqc_use && macd_4_use_c)macd_4_str_c = "C MACD 4, "+tf_string(macd_4_tf_c)+", f="+IntegerToString(macd_4_period_fast_c)+", s="+IntegerToString(macd_4_period_slow_c)+", sig="+IntegerToString(macd_4_period_signal_c);
      string macd_5_str_c = "C MACD 5 = OFF";                       
            if(seqc_use && macd_5_use_c)macd_5_str_c = "C MACD 5, "+tf_string(macd_5_tf_c)+", f="+IntegerToString(macd_5_period_fast_c)+", s="+IntegerToString(macd_5_period_slow_c)+", sig="+IntegerToString(macd_5_period_signal_c);
      string macd_6_str_c = "C MACD 6 = OFF";                       
            if(seqc_use && macd_6_use_c)macd_6_str_c = "C MACD 6, "+tf_string(macd_6_tf_c)+", f="+IntegerToString(macd_6_period_fast_c)+", s="+IntegerToString(macd_6_period_slow_c)+", sig="+IntegerToString(macd_6_period_signal_c);
      
      
      string piv_dis_on_str = "Pivot distances = OFF";        
            if(piv_dis_on)piv_dis_on_str = "Pivot distances = ON, distance from="+IntegerToString(piv_dis_pips_from)+", distance to="+IntegerToString(piv_dis_pips_to);
      string tr_use_on_str = "Time Range = ON, start time="+start_time+", end time="+stop_time;
      
      string ftype = "Arial Bold";
      int line_mult = 0;
      LabelCreate(0,tag+" cond 1 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,pip_adjust_10_str,ftype,8,clrWhite);line_mult++;
     // LabelCreate(0,tag+" cond 2 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,all_valid_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 3 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,use_live_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 3a ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_default,ftype,8,clrWhite);line_mult++;
      //LabelCreate(0,tag+" cond 4 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_all_line_up_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 5 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_crossover_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 5a ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_largest_str,ftype,8,clrWhite);line_mult++;
      
      LabelCreate(0,tag+" cond 6a ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,seqa_tf_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 6 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_1_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 7 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_2_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 8 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_3_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 9 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_4_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 10 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_5_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 11 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_6_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 12a ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_default,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 12 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_1_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 13 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_2_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 14 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_3_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 15 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_4_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 16 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_5_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 17 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_6_str,ftype,8,clrWhite);line_mult++;
      
      if(macd_1_use){LabelCreate(0,tag+" cond 26 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_1_str,ftype,8,clrWhite);line_mult++;}
      if(macd_2_use){LabelCreate(0,tag+" cond 27 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_2_str,ftype,8,clrWhite);line_mult++;}
      if(macd_3_use){LabelCreate(0,tag+" cond 28 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_3_str,ftype,8,clrWhite);line_mult++;}
      if(macd_4_use){LabelCreate(0,tag+" cond 29 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_4_str,ftype,8,clrWhite);line_mult++;}
      if(macd_5_use){LabelCreate(0,tag+" cond 30 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_5_str,ftype,8,clrWhite);line_mult++;}
      if(macd_6_use){LabelCreate(0,tag+" cond 31 ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_6_str,ftype,8,clrWhite);line_mult++;}
      
      LabelCreate(0,tag+" cond 15ba ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,seqb_tf_str,ftype,8,clrWhite);line_mult++;
      if(seqb_use){
         LabelCreate(0,tag+" cond 15bb ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_1b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bc ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_2b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bd ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_3b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15be ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_4b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bf ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_5b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bg ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_6b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bh ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_default,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bi ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_1b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bj ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_2b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bk ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_3b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bl ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_4b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bm ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_5b_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15bn ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_6b_str,ftype,8,clrWhite);line_mult++;
         
         if(macd_1_use_b){LabelCreate(0,tag+" cond 26b ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_1_str_b,ftype,8,clrWhite);line_mult++;}
      if(macd_2_use_b){LabelCreate(0,tag+" cond 27b ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_2_str_b,ftype,8,clrWhite);line_mult++;}
      if(macd_3_use_b){LabelCreate(0,tag+" cond 28b ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_3_str_b,ftype,8,clrWhite);line_mult++;}
      if(macd_4_use_b){LabelCreate(0,tag+" cond 29b ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_4_str_b,ftype,8,clrWhite);line_mult++;}
      if(macd_5_use_b){LabelCreate(0,tag+" cond 30b ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_5_str_b,ftype,8,clrWhite);line_mult++;}
      if(macd_6_use_b){LabelCreate(0,tag+" cond 31b ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_6_str_b,ftype,8,clrWhite);line_mult++;}
      }
     
      LabelCreate(0,tag+" cond 15ca ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,seqc_tf_str,ftype,8,clrWhite);line_mult++;
      if(seqc_use){
         LabelCreate(0,tag+" cond 15cb ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_1c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15cc ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_2c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15cd ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_3c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15ce ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_4c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15cf ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_5c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15cm ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,ma_6c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15cg ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_default,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15ch ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_1c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15ci ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_2c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15cj ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_3c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15ck ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_4c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15cl ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_5c_str,ftype,8,clrWhite);line_mult++;
         LabelCreate(0,tag+" cond 15cn ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,sto_6c_str,ftype,8,clrWhite);line_mult++;
      
         if(macd_1_use_c){LabelCreate(0,tag+" cond 26c ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_1_str_c,ftype,8,clrWhite);line_mult++;}
      if(macd_2_use_c){LabelCreate(0,tag+" cond 27c ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_2_str_c,ftype,8,clrWhite);line_mult++;}
      if(macd_3_use_c){LabelCreate(0,tag+" cond 28c ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_3_str_c,ftype,8,clrWhite);line_mult++;}
      if(macd_4_use_c){LabelCreate(0,tag+" cond 29c ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_4_str_c,ftype,8,clrWhite);line_mult++;}
      if(macd_5_use_c){LabelCreate(0,tag+" cond 30c ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_5_str_c,ftype,8,clrWhite);line_mult++;}
     if(macd_6_use_c){LabelCreate(0,tag+" cond 31c ",0,5,20+12*line_mult,CORNER_LEFT_UPPER,macd_6_str_c,ftype,8,clrWhite);line_mult++;}
      }
      
      LabelCreate(0,tag+" cond 15bo",0,5,20+12*line_mult,CORNER_LEFT_UPPER,piv_dis_on_str,ftype,8,clrWhite);line_mult++;
      LabelCreate(0,tag+" cond 15bp",0,5,20+12*line_mult,CORNER_LEFT_UPPER,tr_use_on_str,ftype,8,clrWhite);
}

string tf_string(ENUM_TIMEFRAMES which_tf)
{
   if(which_tf==PERIOD_M1)return("1m");
   else if(which_tf==PERIOD_M2)return("2m");
   else if(which_tf==PERIOD_M3)return("3m");
   else if(which_tf==PERIOD_M4)return("4m");
   else if(which_tf==PERIOD_M5)return("5m");
   else if(which_tf==PERIOD_M6)return("6m");
   else if(which_tf==PERIOD_M10)return("10m");
   else if(which_tf==PERIOD_M12)return("12m");
   else if(which_tf==PERIOD_M15)return("15m");
   else if(which_tf==PERIOD_M20)return("20m");
   else if(which_tf==PERIOD_M30)return("30m");
   else if(which_tf==PERIOD_H1)return("1h");
   else if(which_tf==PERIOD_H2)return("2h");
   else if(which_tf==PERIOD_H3)return("3h");
   else if(which_tf==PERIOD_H4)return("4h");
   else if(which_tf==PERIOD_H6)return("6h");
   else if(which_tf==PERIOD_H8)return("8h");
   else if(which_tf==PERIOD_H12)return("12h");
   else if(which_tf==PERIOD_D1)return("1d");
   else if(which_tf==PERIOD_W1)return("1w");
   else if(which_tf==PERIOD_MN1)return("1mn");
   else return("0tf");
}

string ma_method_string(ENUM_MA_METHOD which)
{
   string ma_mstring = "";
   if(which==MODE_SMA)      ma_mstring = "SMA ";
   if(which==MODE_EMA)      ma_mstring = "EMA ";
   if(which==MODE_SMMA)      ma_mstring = "SMMA ";
   if(which==MODE_LWMA)      ma_mstring = "LWMA ";
   return(ma_mstring);
   
}

bool LabelCreate(const long              chart_ID=0,               // chart's ID
                 const string            name="Label",             // label name
                 const int               sub_window=0,             // subwindow index
                 const int               x=0,                      // X coordinate
                 const int               y=0,                      // Y coordinate
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // chart corner for anchoring
                 const string            text="Label",             // text
                 const string            font="Arial",             // font
                 const int               font_size=10,             // font size
                 const color             clr=clrRed,               // color
                 const double            angle=0.0,                // text slope
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, // anchor type
                 const bool              back=false,               // in the background
                 const bool              selectable=true,          // highlight to move
                 const bool              selection=false,          // highlight to move
                 const bool              hidden=false,              // hidden in the object list
                 const long              z_order=0)                // priority for mouse click
  {
   ResetLastError();
   if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ": failed to create text label! Error code = ",GetLastError());
      return(false);
     }
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selectable);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   return(true);
  }
  

void updatePivots(bool first = false){

//calculate pivots, if shown
      int limit_p = 1;  if(first)limit_p = ArraySize(p_buff)-2;
      for(int i=limit_p; i>=0 ; i--)
      {
         static int day_p;
         static double ph;
         static double pl;
         static double pc;
         static double dp_level;
         static double s1_level;
         static double s2_level;
         static double s3_level;
         static double r1_level;
         static double r2_level;
         static double r3_level;
      
         MqlDateTime time_p;
         datetime time_i = iTime(Symbol(),PERIOD_CURRENT,i);
         double open_i = iOpen(Symbol(),PERIOD_CURRENT,i);
         TimeToStruct(time_i,time_p);
      
         if(i==limit_p && first){
            day_p = time_p.day_of_week;
            ph = open_i;
            pl = open_i;
         }
   
         //pc = iClose(_Symbol,PERIOD_D1,iBarShift(_Symbol,PERIOD_D1,time[i])+1);
         //ph = iHigh(_Symbol,PERIOD_D1,iBarShift(_Symbol,PERIOD_D1,time[i])+1);
         //pl = iLow(_Symbol,PERIOD_D1,iBarShift(_Symbol,PERIOD_D1,time[i])+1);
   
         if(time_p.day_of_week != day_p && time_p.day_of_week!=6 && time_p.day_of_week!=0){
            day_p = time_p.day_of_week;
            pc = iClose(Symbol(),PERIOD_CURRENT,i+1);
            dp_level = (ph+pl+pc)/3.0;
            r1_level = 2*dp_level - pl;
            s1_level = 2*dp_level - ph;
            r2_level = dp_level + (ph-pl);
            s2_level = dp_level - (ph-pl);
            r3_level = ph + 2*(dp_level-pl);
            s3_level = pl - 2*(ph-dp_level);
            ph = open_i;
            pl = open_i;
            //rect_counter++;
      
            /*if(piv_show && piv_rect){
               double min_distance_from = piv_dis_pips_from*price2pip;
               double min_distance_to = piv_dis_pips_to*price2pip;
               datetime t2 = time[i];//time[i]+60*60*24;//requested to not print forward rects, t2 will be updated to live candle
               //if(time_p.day_of_week==5)t2+=2*24*60*60;
               //if(time_p.day_of_week==0)t2+=24*60*60;
               
               RectangleCreate(0,tag+" rect r3  "+IntegerToString(rect_counter),0,time[i],r3_level-min_distance_to,t2,r3_level+min_distance_from,piv_rect_clr_r,STYLE_SOLID,1,true);
               RectangleCreate(0,tag+" rect r2  "+IntegerToString(rect_counter),0,time[i],r2_level-min_distance_to,t2,r2_level+min_distance_from,piv_rect_clr_r,STYLE_SOLID,1,true);
               RectangleCreate(0,tag+" rect r1  "+IntegerToString(rect_counter),0,time[i],r1_level-min_distance_to,t2,r1_level+min_distance_from,piv_rect_clr_r,STYLE_SOLID,1,true);
               RectangleCreate(0,tag+" rect piv  "+IntegerToString(rect_counter),0,time[i],dp_level-min_distance_from,t2,dp_level+min_distance_from,piv_rect_clr_p,STYLE_SOLID,1,true);
               RectangleCreate(0,tag+" rect s1  "+IntegerToString(rect_counter),0,time[i],s1_level+min_distance_to,t2,s1_level-min_distance_from,piv_rect_clr_s,STYLE_SOLID,1,true);
               RectangleCreate(0,tag+" rect s2 "+IntegerToString(rect_counter),0,time[i],s2_level+min_distance_to,t2,s2_level-min_distance_from,piv_rect_clr_s,STYLE_SOLID,1,true);
               RectangleCreate(0,tag+" rect s3  "+IntegerToString(rect_counter),0,time[i],s3_level+min_distance_to,t2,s3_level-min_distance_from,piv_rect_clr_s,STYLE_SOLID,1,true);
            }//show rects*/
         }//new pivot
      
         double high_i = iHigh(Symbol(),PERIOD_CURRENT,i);
         double low_i = iLow(Symbol(),PERIOD_CURRENT,i);
      
         if(high_i > ph)ph = high_i;
         if(low_i < pl)pl = low_i;
         
        /* if(piv_show && piv_rect){
            ObjectSetInteger(0,tag+" rect r3  "+IntegerToString(rect_counter),OBJPROP_TIME,1,time[i]);
            ObjectSetInteger(0,tag+" rect r2  "+IntegerToString(rect_counter),OBJPROP_TIME,1,time[i]);
            ObjectSetInteger(0,tag+" rect r1  "+IntegerToString(rect_counter),OBJPROP_TIME,1,time[i]);
            ObjectSetInteger(0,tag+" rect piv  "+IntegerToString(rect_counter),OBJPROP_TIME,1,time[i]);
            ObjectSetInteger(0,tag+" rect s1  "+IntegerToString(rect_counter),OBJPROP_TIME,1,time[i]);
            ObjectSetInteger(0,tag+" rect s2  "+IntegerToString(rect_counter),OBJPROP_TIME,1,time[i]);
            ObjectSetInteger(0,tag+" rect s3  "+IntegerToString(rect_counter),OBJPROP_TIME,1,time[i]);
         }*/
         
         p_buff[i] = dp_level;
         ps1_buff[i] = s1_level;
         ps2_buff[i] = s2_level;
         ps3_buff[i] = s3_level;
         pr1_buff[i] = r1_level;
         pr2_buff[i] = r2_level;
         pr3_buff[i] = r3_level;
         
         /*if(piv_show && piv_show_text){
            ObjectSetDouble(NULL,tag+" r3 text",OBJPROP_PRICE,pr3_buff[i]);
            ObjectSetDouble(NULL,tag+" r2 text",OBJPROP_PRICE,pr2_buff[i]);
            ObjectSetDouble(NULL,tag+" r1 text",OBJPROP_PRICE,pr1_buff[i]);
            ObjectSetDouble(NULL,tag+" pivot text",OBJPROP_PRICE,p_buff[i]);
            ObjectSetDouble(NULL,tag+" s1 text",OBJPROP_PRICE,ps1_buff[i]);
            ObjectSetDouble(NULL,tag+" s2 text",OBJPROP_PRICE,ps2_buff[i]);
            ObjectSetDouble(NULL,tag+" s3 text",OBJPROP_PRICE,ps3_buff[i]);
            
            ObjectSetInteger(NULL,tag+" r3 text",OBJPROP_TIME,time[0]+piv_text_offset*PeriodSeconds());
            ObjectSetInteger(NULL,tag+" r2 text",OBJPROP_TIME,time[0]+piv_text_offset*PeriodSeconds());
            ObjectSetInteger(NULL,tag+" r1 text",OBJPROP_TIME,time[0]+piv_text_offset*PeriodSeconds());
            ObjectSetInteger(NULL,tag+" pivot text",OBJPROP_TIME,time[0]+piv_text_offset*PeriodSeconds());
            ObjectSetInteger(NULL,tag+" s1 text",OBJPROP_TIME,time[0]+piv_text_offset*PeriodSeconds());
            ObjectSetInteger(NULL,tag+" s2 text",OBJPROP_TIME,time[0]+piv_text_offset*PeriodSeconds());
            ObjectSetInteger(NULL,tag+" s3 text",OBJPROP_TIME,time[0]+piv_text_offset*PeriodSeconds());
            
            ObjectSetString(NULL,tag+" r3 text",OBJPROP_TEXT,"R3 = "+DoubleToString(pr3_buff[i],Digits()));
            ObjectSetString(NULL,tag+" r2 text",OBJPROP_TEXT,"R2 = "+DoubleToString(pr2_buff[i],Digits()));
            ObjectSetString(NULL,tag+" r1 text",OBJPROP_TEXT,"R1 = "+DoubleToString(pr1_buff[i],Digits()));
            ObjectSetString(NULL,tag+" pivot text",OBJPROP_TEXT,"Pivot = "+DoubleToString(p_buff[i],Digits()));
            ObjectSetString(NULL,tag+" s1 text",OBJPROP_TEXT,"S1 = "+DoubleToString(ps1_buff[i],Digits()));
            ObjectSetString(NULL,tag+" s2 text",OBJPROP_TEXT,"S2 = "+DoubleToString(ps2_buff[i],Digits()));
            ObjectSetString(NULL,tag+" s3 text",OBJPROP_TEXT,"S3 = "+DoubleToString(ps3_buff[i],Digits()));
         }*/
      }//pivot i loop 
   
}  

double Price2pip(string symbol){

   return SymbolInfoDouble(symbol,SYMBOL_POINT)*pip_adjust_10*10;
}
